/* Sistemas Integrados TEKNISA
   Compras e Suprimentos

Nome: 8910_SUPSTPO.sql

Descrio:
- insere os dados selecionados para apurao da compra

Criao:
26/08/2006 - Marcelo Alexsandro Souza Silva
*/

CREATE OR REPLACE PROCEDURE APURA_COMPRA
                     (P_CDCENTCMP   IN  ITMAPURPREC.CDCENTITMAP%TYPE,
                      P_NRSEQAPUR   IN  ITMAPURPREC.NRSEQITMAP%TYPE,
                      P_DTINI       IN  ITMAPURPREC.DTENTRAPUT%TYPE,
                      P_DTFIN       IN  ITMAPURPREC.DTENTRAPUT%TYPE,
                      P_FILIPROC    IN  FILIAL.CDFILIAL%TYPE,
                      P_ROWSAFFECT  OUT VARCHAR2,
                      P_CDOPERLANC  IN  VARCHAR2,
                      P_CDCOMPRADOR IN  VARCHAR2,
                      P_NRCOMPRA    IN  VARCHAR2)
IS
   V_QTACOMPRAR     ITEMSOLI.QTSOLIPROD%TYPE;
   V_QTACOMPRAR_AUX ITEMSOLI.QTSOLIPROD%TYPE;
   V_QTDECOMP       ITEMAUTF.QTPROGENTAF%TYPE;
   V_CTPRODATIV     INT;
   V_CTPRODCMP      INT;
   V_CTIMPOSTO      INT;
   V_VRARREDCMP     PRODUTO.VRARREDCMP%TYPE;
   V_IDPRODWEB      AUTOFORNE.IDAFPRODWEB%TYPE;
   V_IDAFOPERLOG    AUTOFORNE.IDAFOPERLOG%TYPE;
   V_IDCONSPRSOL    PARASUPRI.IDCONSPRSOL%TYPE;
   V_VRARREDEMPE    PRODFORNCOMP.VRARREDEMPE%TYPE;
   V_CDEMPRESA      EMPRESA.CDEMPRESA%TYPE;
   V_CONCKEY        VARCHAR2(200);
   V_IDTIPEMIT      VARCHAR2(1);
   V_EMITENTE       VARCHAR2(4);
   V_DSPZOPGTCONC   VARCHAR2(2000);
   V_IDUTISTATCOT   VARCHAR2(1);
   V_AUX_LISTA      VARCHAR2(2000);
   V_IDSEPAFIMP     VARCHAR2(1);
   V_CDFILIOPELOG   VARCHAR2(2000);
   V_IDPRODATIV     VARCHAR2(1);
   V_COUNT          INT;
   V_CDFILIAL       ITEMSOLI.CDFILSOLI%TYPE;
   V_CDFILIAL_PARAM ITEMSOLI.CDFILSOLI%TYPE;
BEGIN
  P_ROWSAFFECT := 'N';
  V_QTACOMPRAR := 0;
  SELECT
     MAX(IDCONSPRSOL),
     MAX(IDSEPAFIMP),
     MAX(NVL(IDUTISTATCOT, 'N'))
  INTO
     V_IDCONSPRSOL, /* Considerar somente Produto Solicitado para Cotao e AF Automtica */
     V_IDSEPAFIMP,  /*Gera AF's Separadas de Acordo com o Imposto*/
     V_IDUTISTATCOT
  FROM
     PARASUPRI
  WHERE
     CDFILIAL = P_CDCENTCMP;

  INSERT INTO
     APURPRECO
    (CDFILCENTCMP, NRAPURPREC, CDCOMPRADOR, DTINIAPUPREC,
     DTFINAPUPREC, IDSITAPUPREC, DTAPURPREC,CDOPERADOR, CDFILLANC)
   VALUES
    (P_CDCENTCMP, P_NRSEQAPUR, P_CDCOMPRADOR, P_DTINI,
     P_DTFIN, '1', SYSDATE, P_CDOPERLANC, P_FILIPROC);

  INSERT INTO APROVCOMPRA
     (NRCOMPRA, CDGERENTE)
     SELECT P_NRCOMPRA, CDOPERGERE
       FROM GERECOMP G
      WHERE CDOPERCOMP = P_CDCOMPRADOR
        AND NOT EXISTS (SELECT 1
                          FROM APROVCOMPRA AC
                         WHERE AC.NRCOMPRA  = P_NRCOMPRA
                           AND G.CDOPERGERE = AC.CDGERENTE);


  FOR C_FILGRUPFILI IN
     (SELECT DISTINCT
         PRODCOMPRA.CDFILSOLI AS CDFILIAL
      FROM
         PRODCOMPRA
      WHERE
         (PRODCOMPRA.NRCOMPRA = P_NRCOMPRA)
      )
  LOOP
     INSERT INTO PRODCMPFILI_TMP
        (NRSEQAPUR,
         CDFILIAL,
         CDPRODUTO)
     SELECT P_NRSEQAPUR AS NRSEQAPUR,
            CDFILIAL,
            CDPRODUTO
     FROM
        PRODCMPFILI
     WHERE
        CDFILIAL = C_FILGRUPFILI.CDFILIAL;

     IF NVL(V_IDCONSPRSOL, 'N') = 'N' THEN
        FOR C_ITEMSOLI IN
        (SELECT /*+ ORDERED */
            PRODUTO.CDPRODESTO,
            ITEMSOLI.CDFILSOLI,
            ITEMSOLI.DTPROGENTR,
            FILIAL.CDREGIAO,
            SUM(DECODE(ITEMSOLI.QTSOLIPROD*PRODUTO.VRFATOCONV, NULL, 0, ITEMSOLI.QTSOLIPROD*PRODUTO.VRFATOCONV)) AS QTDEACOMP /* QUANTIDADE CONVERTIDA PARA ESTOQUE */
         FROM
            FILIAL,
            PRODCOMPRA,
            ITEMSOLI,
            PRODUTO
         WHERE
            (FILIAL.CDFILIAL      = C_FILGRUPFILI.CDFILIAL)     AND
            (PRODCOMPRA.NRCOMPRA  = P_NRCOMPRA)                 AND
            (PRODCOMPRA.CDFILSOLI = FILIAL.CDFILIAL)            AND
            (ITEMSOLI.CDFILSOLI   = PRODCOMPRA.CDFILSOLI)       AND
            (ITEMSOLI.CDFILLAN    = PRODCOMPRA.CDFILLAN)        AND
            (ITEMSOLI.NRSOLICMP   = PRODCOMPRA.NRSOLICMP)       AND
            (ITEMSOLI.CDPRODUTO   = PRODCOMPRA.CDPRODUTO)       AND
            (ITEMSOLI.DTPROGENTR  = PRODCOMPRA.DTPROGENTR)      AND
            (ITEMSOLI.IDITMCONS   = 'N')                        AND
            (DECODE(FILIAL.CDFILCENTCMP, NULL, FILIAL.CDFILIAL, FILIAL.CDFILCENTCMP) = P_CDCENTCMP) AND
            (FILIAL.IDCNTRRESC   <> 'S') AND
            (ITEMSOLI.CDPRODUTO   = PRODUTO.CDPRODUTO) AND
            DECODE(ITEMSOLI.IDSOLIAPROV, NULL, 'S', ITEMSOLI.IDSOLIAPROV) = 'S' AND
            EXISTS(SELECT
                      1
                   FROM
                      PRODCOMP,
                      PRODUTO PC
                   WHERE
                      PRODCOMP.CDPRODUTO  = PC.CDPRODUTO         AND
                      PRODCOMP.CDOPERADOR = P_CDCOMPRADOR AND
                      PRODUTO.CDARVPROD LIKE PC.CDARVPROD || '%')
         GROUP BY
            FILIAL.CDREGIAO,
            ITEMSOLI.CDFILSOLI,
            PRODUTO.CDPRODESTO,
            ITEMSOLI.DTPROGENTR
         )LOOP
          SELECT
             NVL(MAX(PRODFILI.IDPRODATIV), 'A')
          INTO
             V_IDPRODATIV
          FROM
             PRODFILI
          WHERE
             PRODFILI.CDFILIAL  = C_ITEMSOLI.CDFILSOLI AND
             PRODFILI.CDPRODUTO = C_ITEMSOLI.CDPRODESTO;

          IF V_IDPRODATIV = 'A' THEN
             V_CTPRODCMP := 0;
             SELECT
                COUNT(*)
             INTO
                V_CTPRODCMP
             FROM
                PRODCMPFILI_TMP PRODCMPFILI,
                PRODUTO,
                PRODUTO PRODESTO
             WHERE
                PRODESTO.CDPRODUTO    = C_ITEMSOLI.CDPRODESTO  AND
                PRODCMPFILI.CDPRODUTO = PRODUTO.CDPRODUTO      AND
                PRODCMPFILI.CDFILIAL  = C_ITEMSOLI.CDFILSOLI   AND
                PRODCMPFILI.NRSEQAPUR = P_NRSEQAPUR            AND
                PRODCMPFILI.CDFILIAL <> P_FILIPROC             AND
                PRODESTO.CDARVPROD LIKE PRODUTO.CDARVPROD||'%' AND
                PRODUTO.CDARVPROD > (SELECT DECODE(MAX(PR.CDARVPROD), NULL, '0', MAX(PR.CDARVPROD))
                                     FROM PRODNCMP, PRODUTO PR
                                     WHERE PRODNCMP.CDPRODUTO = PR.CDPRODUTO AND
                                           PRODESTO.CDARVPROD LIKE PR.CDARVPROD||'%' AND
                                           PRODNCMP.CDFILIAL = C_ITEMSOLI.CDFILSOLI);
             IF V_CTPRODCMP = 0 THEN
                V_CTPRODCMP := 1;
             ELSE
                V_CTPRODCMP := 0;
             END IF;

             IF V_CTPRODCMP > 0 THEN
               V_QTACOMPRAR := C_ITEMSOLI.QTDEACOMP;
               V_QTDECOMP := 0;
               BEGIN
                 SELECT /*+ index (itemautf itemautf_03) */
                    SUM(ITEMAUTF.QTPROGENTAF * PRODUTO.VRFATOCONV)
                 INTO
                    V_QTDECOMP  /* QTDE CONVERTIDA PARA ESTOQUE */
                 FROM
                   AUTOFORNE,
                   ITEMAUTF,
                   PRODUTO,
                   ITMAPURPREC
                 WHERE
                   (PRODUTO.CDPRODESTO     = C_ITEMSOLI.CDPRODESTO)                     AND
                   (AUTOFORNE.CDFILDEST    = ITEMAUTF.CDFILDEST)                        AND
                   (AUTOFORNE.CDFILLANC    = ITEMAUTF.CDFILLANC)                        AND
                   (AUTOFORNE.NRAUTOFORN   = ITEMAUTF.NRAUTOFORN)                       AND
                   (AUTOFORNE.IDAUTOFORNEX = 'N')                                       AND
                   (DECODE(AUTOFORNE.IDBAIXAAF, NULL, '0', AUTOFORNE.IDBAIXAAF) <> '5') AND
                   (ITEMAUTF.CDFILDEST     =  C_ITEMSOLI.CDFILSOLI)                     AND
                   (ITEMAUTF.CDPRODUTO     =  PRODUTO.CDPRODUTO)                        AND
                   (ITEMAUTF.DTENTRITMSOL  =  C_ITEMSOLI.DTPROGENTR)                    AND
                   (ITEMAUTF.CDFILDEST     = ITMAPURPREC.CDFILIAP)                      AND
                   (ITEMAUTF.CDMARCA       = ITMAPURPREC.CDMARCITMAP)                   AND
                   (ITEMAUTF.CDPRODUTO     = ITMAPURPREC.CDPRODITMAP)                   AND
                   (ITEMAUTF.DTPROGENTAF   = ITMAPURPREC.DTENTRAPUT)                    AND
                   (AUTOFORNE.CDFORNECED   = ITMAPURPREC.CDFORNITMAP)                   AND
                   (AUTOFORNE.NRSEQAPURAF  = ITMAPURPREC.NRSEQITMAP)                    AND
                   (NVL(ITMAPURPREC.NRCOMPRA, P_NRCOMPRA)  = P_NRCOMPRA)               AND
                   (ITMAPURPREC.NRCOMPRA IS NOT NULL)
                 GROUP BY
                   ITEMAUTF.CDFILDEST,
                   ITEMAUTF.DTENTRITMSOL,
                   PRODUTO.CDPRODESTO;
               EXCEPTION
                 WHEN OTHERS THEN
                   V_QTDECOMP := 0;
               END;
               V_QTACOMPRAR := V_QTACOMPRAR - V_QTDECOMP;

               IF TRUNC(V_QTACOMPRAR,3) > 0 THEN
           --      DBMS_OUTPUT.PUT_LINE('COLETA');

                  FOR C_GRAVA IN (
                  SELECT /*+ INDEX(ITEMCOLE ITEMCOLE_01)*/
                     ITEMCOLE.CDFILIAL,
                     ITEMCOLE.CDPRODUTO,
                     PRODUTO.VRFATOCONV,
                     ITEMCOLE.NRCOLEPRECO,
                     ITEMCOLE.CDFORNECED,
                     ITEMCOLE.CDREGIAO,
                     ITEMCOLE.CDMARCA,
                     ITEMCOLE.CDTIPCOB,
                     ITEMCOLE.CDFORMPGTO,
                     ITEMCOLE.IDUTDIAPGCOL,
                     ITEMCOLE.IDTPFOPGTCOL,
                     ITEMCOLE.IDTIPFREITM,
                     ITEMCOLE.NRPARCPGTCOL,
                     ITEMCOLE.CDSEGMARCCOL,
                     ITEMCOLE.VRPRECUNIITM,
                     ITEMCOLE.VRPERDESITM,
                     ITEMCOLE.NRDIAPGFXCOL,
                     ITEMCOLE.VRPRECECOITM,
                     ITEMCOLE.VRPRECOITMPI,
                     ITEMCOLE.IDITMLISPREC,
                     ITEMCOLE.NRSEQPRELIST
                   FROM
                     ITEMCOLE,
                     PRODUTO,
                     FORNECEDOR,
                     COLETAPR
                   WHERE
                     COLETAPR.CDFILIAL      = P_CDCENTCMP                                         AND
                     COLETAPR.CDOPERADOR    = P_CDCOMPRADOR                                       AND
                     COLETAPR.NRCOMPRA      = P_NRCOMPRA                                          AND
                     COLETAPR.CDFILIAL      = ITEMCOLE.CDFILIAL                                   AND
                     COLETAPR.NRCOLEPRECO   = ITEMCOLE.NRCOLEPRECO                                AND
                     PRODUTO.CDPRODUTO      = ITEMCOLE.CDPRODUTO                                  AND
                     ITEMCOLE.VRPRECUNIITM  <> 0                                                  AND
                     PRODUTO.CDPRODESTO     = C_ITEMSOLI.CDPRODESTO                               AND
                     ITEMCOLE.CDREGIAO      = C_ITEMSOLI.CDREGIAO                                 AND
                     C_ITEMSOLI.DTPROGENTR BETWEEN ITEMCOLE.DTINIVALITM AND ITEMCOLE.DTFINVALITM  AND
                     FORNECEDOR.CDFORNECED  = ITEMCOLE.CDFORNECED AND
                     FORNECEDOR.IDSITUCADA  = 'A'                 AND
                     FORNECEDOR.IDTIPOFORN <> 'A'                 AND
                     ((V_IDUTISTATCOT = 'N') OR (NVL(COLETAPR.IDSITUCOLETA, 'C') = 'C')) AND

                     NOT EXISTS
                      (SELECT
                          1
                       FROM
                          REFOREG
                       WHERE
                          REFOREG.CDREGIAO   = C_ITEMSOLI.CDREGIAO AND
                          REFOREG.CDFORNECED = ITEMCOLE.CDFORNECED) AND

                     NOT EXISTS
                     (SELECT
                         1
                      FROM
                         QFOPRODFORN,
                         PARASUPRI
                      WHERE
                         PARASUPRI.CDFILIAL = P_CDCENTCMP  AND
                         (QFOPRODFORN.CDPRODUTO = PRODUTO.CDPRODUTO) AND
                         (QFOPRODFORN.CDFORNECED= ITEMCOLE.CDFORNECED) AND
                         ((QFOPRODFORN.IDFORNAPROV = 'N' AND QFOPRODFORN.IDFORNAUTOR = 'N') OR
                          ((QFOPRODFORN.IDFORNAPROV = 'S') AND
                             ((PARASUPRI.IDULTIDTVALQ = 'M' AND
                               COLETAPR.DTCOLEPREC > LAST_DAY(QFOPRODFORN.DTVALPRFORN)) OR
                              (PARASUPRI.IDULTIDTVALQ = 'D' AND
                               COLETAPR.DTCOLEPREC > QFOPRODFORN.DTVALPRFORN)) ) )) AND

                     NOT EXISTS
                       (SELECT
                           1
                        FROM
                           QFOMARPROD,
                           PARASUPRI
                        WHERE
                          (PARASUPRI.CDFILIAL = P_CDCENTCMP)            AND
                          (QFOMARPROD.CDPRODUTO = PRODUTO.CDPRODUTO) AND
                          (QFOMARPROD.CDMARCA   = ITEMCOLE.CDMARCA)     AND
                          ((QFOMARPROD.IDAPRMARPRO = 'N' AND QFOMARPROD.IDAUTMARPRO = 'N') OR
                           ((QFOMARPROD.IDAPRMARPRO = 'S') AND
                              ((PARASUPRI.IDULTIDTVALQ = 'M' AND
                                COLETAPR.DTCOLEPREC > LAST_DAY(QFOMARPROD.DTVALAPROVA)) OR
                               (PARASUPRI.IDULTIDTVALQ = 'D' AND
                                COLETAPR.DTCOLEPREC > QFOMARPROD.DTVALAPROVA)) ) )) AND

                     EXISTS
                       (SELECT
                           1
                        FROM
                           QFOMARPROD
                        WHERE
                           QFOMARPROD.CDPRODUTO = PRODUTO.CDPRODUTO AND
                           QFOMARPROD.CDMARCA   = ITEMCOLE.CDMARCA

                        UNION

                        SELECT
                           1
                        FROM
                           PARASUPRI
                        WHERE
                           PARASUPRI.CDFILIAL    = P_CDCENTCMP AND
                           (PARASUPRI.IDMARSEMQUA = 'N' OR PARASUPRI.IDMARSEMQUA IS NULL)) AND

                     NOT EXISTS
                       (SELECT
                           1
                        FROM
                           QUALIFICACAO,
                           PARASUPRI
                        WHERE (FORNECEDOR.CDQUALIF       = QUALIFICACAO.CDQUALIF) AND
                              (PARASUPRI.CDFILIAL        = P_CDCENTCMP)           AND
                              (FORNECEDOR.IDFORNAUTO     = 'N')                   AND
                              ((QUALIFICACAO.IDPERCOTCMP = '2')                   OR
                               ((PARASUPRI.IDULTIDTVALQ  = 'D'                    AND
                                 COLETAPR.DTCOLEPREC > FORNECEDOR.DTVALQUALIF)       OR
                               (PARASUPRI.IDULTIDTVALQ = 'M'                      AND
                                COLETAPR.DTCOLEPREC > LAST_DAY(FORNECEDOR.DTVALQUALIF))))) AND

                     NOT EXISTS /* Tirando fornecedores que no atendam s filiais */
                      (SELECT
                          1
                       FROM
                          REFORFIL
                       WHERE
                          REFORFIL.CDFILIAL   = C_ITEMSOLI.CDFILSOLI AND
                          REFORFIL.CDPERIENTR IS NULL AND
                          REFORFIL.CDFORNECED = ITEMCOLE.CDFORNECED ))
                    LOOP
                      V_CTIMPOSTO := NULL;
                      V_CONCKEY   := NULL;
                      IF V_IDSEPAFIMP = 'S' THEN
                         SELECT
                            COUNT(*)
                         INTO
                            V_CTIMPOSTO
                         FROM
                            IMPCOLET
                         WHERE
                            CDFILIAL    = C_GRAVA.CDFILIAL    AND
                            NRCOLEPRECO = C_GRAVA.NRCOLEPRECO AND
                            CDMARCA     = C_GRAVA.CDMARCA     AND
                            CDREGIAO    = C_GRAVA.CDREGIAO    AND
                            CDFORNECED  = C_GRAVA.CDFORNECED  AND
                            CDPRODUTO   = C_GRAVA.CDPRODUTO;
                         IF V_CTIMPOSTO = 0 THEN
                            V_CONCKEY := '';
                         ELSE
                            IF V_CTIMPOSTO = 1 THEN
                               SELECT DISTINCT
                                  CDIMPOSTO
                               INTO
                                  V_CONCKEY
                               FROM
                                  IMPCOLET
                               WHERE
                                  CDFILIAL    = C_GRAVA.CDFILIAL    AND
                                  NRCOLEPRECO = C_GRAVA.NRCOLEPRECO AND
                                  CDMARCA     = C_GRAVA.CDMARCA     AND
                                  CDREGIAO    = C_GRAVA.CDREGIAO    AND
                                  CDFORNECED  = C_GRAVA.CDFORNECED  AND
                                  CDPRODUTO   = C_GRAVA.CDPRODUTO;
                            ELSE
                               IF V_CTIMPOSTO > 1 THEN
                                  V_CONCKEY := '*';
                               END IF;
                            END IF;
                         END IF;
                      END IF;
                      V_EMITENTE  := EMITENTE(C_ITEMSOLI.CDFILSOLI, C_GRAVA.CDPRODUTO, C_GRAVA.CDFORNECED);
                      V_CDEMPRESA := SUBSTR(V_EMITENTE, 3, 2);
                      V_CONCKEY   := V_CONCKEY||C_GRAVA.CDFILIAL|| C_GRAVA.CDFORNECED ||SUBSTR(V_EMITENTE, 3, 2)||
                                     C_GRAVA.IDTPFOPGTCOL ||
                                     C_GRAVA.CDTIPCOB     || C_GRAVA.IDTIPFREITM  ||
                                     C_GRAVA.CDFORMPGTO   || C_GRAVA.NRPARCPGTCOL ||
                                     C_GRAVA.NRDIAPGFXCOL || C_GRAVA.IDUTDIAPGCOL ||SUBSTR(V_EMITENTE, 1, 1);
                      V_IDTIPEMIT := SUBSTR(V_EMITENTE, 1, 1);
                      V_DSPZOPGTCONC := CONCAT_PZO_PAGTO (C_GRAVA.CDFILIAL,   C_GRAVA.NRCOLEPRECO,
                                                          C_GRAVA.CDFORNECED, C_GRAVA.CDPRODUTO,
                                                          C_GRAVA.CDMARCA,    C_GRAVA.CDREGIAO);
                      SELECT
                         DECODE(MAX(VRARREDCMP), NULL, 0, MAX(VRARREDCMP)) INTO V_VRARREDCMP
                      FROM
                         PRODUTO
                      WHERE
                         CDPRODUTO = C_GRAVA.CDPRODUTO;

                      V_QTACOMPRAR_AUX := V_QTACOMPRAR / C_GRAVA.VRFATOCONV; /* CONVERTE PARA UNIDADE DE COMPRA */
                      IF (MOD(V_QTACOMPRAR_AUX, V_VRARREDCMP) <> 0) AND V_VRARREDCMP > 0 THEN
                         V_QTACOMPRAR_AUX := CEIL(V_QTACOMPRAR_AUX / V_VRARREDCMP) * V_VRARREDCMP;
                      END IF;
                      V_IDAFOPERLOG := 'X';
                      SELECT
                         DECODE(MAX('2'), NULL, 'X', MAX('2')) INTO V_IDAFOPERLOG
                      FROM
                         PARAMPRODSUP
                      WHERE
                         CDFILIAL     = C_ITEMSOLI.CDFILSOLI AND
                         CDPRODUTO    = C_GRAVA.CDPRODUTO    AND
                         CDFILIOPELOG IS NOT NULL;

                      V_IDPRODWEB := 'N';
                      SELECT
                         DECODE(MAX(PARAMPRODSUP.IDPRODWEB), NULL, 'N', MAX(PARAMPRODSUP.IDPRODWEB)) INTO V_IDPRODWEB
                      FROM
                         PARAMPRODSUP
                      WHERE
                         CDFILIAL   = C_ITEMSOLI.CDFILSOLI AND
                         CDPRODUTO  = C_GRAVA.CDPRODUTO    AND
                         CDFORNECED = C_GRAVA.CDFORNECED;

                      SELECT
                         MAX(CDFILIOPELOG)
                      INTO
                         V_CDFILIOPELOG
                      FROM
                         PARAMPRODSUP
                      WHERE
                         CDFILIAL     = C_ITEMSOLI.CDFILSOLI AND
                         CDPRODUTO    = C_GRAVA.CDPRODUTO;
                      IF V_CDFILIOPELOG IS NULL THEN
                         V_CDFILIOPELOG := 'OL_NULL';
                      END IF;

                      INSERT INTO ITMAPURPREC
                      (CDCENTITMAP,  NRSEQITMAP,   CDFILIAP,
                       DTENTRAPUT,   CDPRODITMAP,  NRCOLEITMAP,
                       CDFORNITMAP,  CDREGITMAP,   CDMARCITMAP,
                       QTSOLACOMP,   QTACOMP,      CDTIPCOBAP,
                       CDEMPRESAAP,  CDFORMPGTOAP, IDULTDIAPGTAF,
                       CONCKEYAP,    IDTPFORPGTAP, IDTIPOEMITAP,
                       IDTIPOFRETAP, NRPARCPGTOAP, CDSEGMARCCOL,
                       VRPRECUNIAP,  VRPERDESIAP,  NRDIAPGFIAP,
                       DSPZOPGTCOAP, VRPRECECOAP,  VRPRECONPIAP,
                       IDITMLISPRAP, NRLISTAITMAP, NRCOMPRA)
                      VALUES(P_CDCENTCMP,
                             P_NRSEQAPUR,
                             C_ITEMSOLI.CDFILSOLI,
                             C_ITEMSOLI.DTPROGENTR,
                             C_GRAVA.CDPRODUTO,
                             C_GRAVA.NRCOLEPRECO,
                             C_GRAVA.CDFORNECED,
                             C_GRAVA.CDREGIAO,
                             C_GRAVA.CDMARCA,
                             V_QTACOMPRAR_AUX,
                             V_QTACOMPRAR_AUX,
                             C_GRAVA.CDTIPCOB,
                             V_CDEMPRESA,
                             C_GRAVA.CDFORMPGTO,
                             C_GRAVA.IDUTDIAPGCOL,
                             V_CONCKEY||V_CDFILIOPELOG||V_IDPRODWEB||V_IDAFOPERLOG,
                             C_GRAVA.IDTPFOPGTCOL,
                             V_IDTIPEMIT,
                             C_GRAVA.IDTIPFREITM,
                             C_GRAVA.NRPARCPGTCOL,
                             C_GRAVA.CDSEGMARCCOL,
                             C_GRAVA.VRPRECUNIITM,
                             C_GRAVA.VRPERDESITM,
                             C_GRAVA.NRDIAPGFXCOL,
                             V_DSPZOPGTCONC,
                             C_GRAVA.VRPRECECOITM,
                             C_GRAVA.VRPRECOITMPI,
                             C_GRAVA.IDITMLISPREC,
                             C_GRAVA.NRSEQPRELIST,
                             P_NRCOMPRA);
                      IF SQL%ROWCOUNT > 0 THEN
                       P_ROWSAFFECT := 'S';
                          IF NVL(V_CDFILIAL, 'XXXX') <> C_ITEMSOLI.CDFILSOLI THEN
                             SELECT MAX(PARCMPSUP.CDFILIAL)
                               INTO V_CDFILIAL_PARAM
                               FROM PARCMPSUP, PARASUPRI, FILIAL
                              WHERE PARCMPSUP.CDFILIAL = FILIAL.CDFILIAL
                                AND PARASUPRI.CDFILIAL = NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL)
                                AND NVL(PARCMPSUP.IDUTAPROVSOL, 'N')    = 'S'
                                AND NVL(PARASUPRI.IDULTDESTSOL, 'N')    = 'S'
                                AND NVL(PARASUPRI.IDEXIGAPRGERCMP, 'N') = 'S'
                                AND PARCMPSUP.CDSUBGRPROD IS NOT NULL
                                AND FILIAL.CDFILIAL = C_ITEMSOLI.CDFILSOLI;
                             IF V_CDFILIAL_PARAM IS NOT NULL THEN
                                DELETE
                                  FROM APROVCOMPRA
                                 WHERE NRCOMPRA = P_NRCOMPRA;
                                UPDATE COMPRA
                                   SET IDSITUCOMPRA = '8'
                                 WHERE NRCOMPRA = P_NRCOMPRA;
                             END IF;
                             V_CDFILIAL := C_ITEMSOLI.CDFILSOLI;
                          END IF;
                      END IF;
                    END LOOP;
               END IF;
               COMMIT;
               V_QTACOMPRAR := 0;
             END IF;
          END IF;
        END LOOP;
     ELSE
        FOR C_ITEMSOLI IN
          (SELECT /*+ ORDERED */
              ITEMSOLI.CDPRODUTO,
              ITEMSOLI.CDFILSOLI,
              ITEMSOLI.DTPROGENTR,
              FILIAL.CDREGIAO,
              SUM(ITEMSOLI.QTSOLIPROD) AS QTDEACOMP /* QUANTIDADE CONVERTIDA PARA ESTOQUE */
           FROM
              FILIAL,
              PRODCOMPRA,
              ITEMSOLI,
              PRODUTO
           WHERE
            (FILIAL.CDFILIAL      = C_FILGRUPFILI.CDFILIAL)     AND
            (PRODCOMPRA.NRCOMPRA  = P_NRCOMPRA)                 AND
            (PRODCOMPRA.CDFILSOLI = FILIAL.CDFILIAL)            AND
            (ITEMSOLI.CDFILSOLI   = PRODCOMPRA.CDFILSOLI)       AND
            (ITEMSOLI.CDFILLAN    = PRODCOMPRA.CDFILLAN)        AND
            (ITEMSOLI.NRSOLICMP   = PRODCOMPRA.NRSOLICMP)       AND
            (ITEMSOLI.CDPRODUTO   = PRODCOMPRA.CDPRODUTO)       AND
            (ITEMSOLI.DTPROGENTR  = PRODCOMPRA.DTPROGENTR)      AND
            (ITEMSOLI.IDITMCONS   = 'N')                        AND
            (DECODE(FILIAL.CDFILCENTCMP, NULL, FILIAL.CDFILIAL, FILIAL.CDFILCENTCMP) = P_CDCENTCMP) AND
            (FILIAL.IDCNTRRESC   <> 'S') AND
            (ITEMSOLI.CDPRODUTO   = PRODUTO.CDPRODUTO) AND
            DECODE(ITEMSOLI.IDSOLIAPROV, NULL, 'S', ITEMSOLI.IDSOLIAPROV) = 'S' AND
            EXISTS(SELECT
                      1
                   FROM
                      PRODCOMP,
                      PRODUTO PC
                   WHERE
                      PRODCOMP.CDPRODUTO  = PC.CDPRODUTO  AND
                      PRODCOMP.CDOPERADOR = P_CDCOMPRADOR AND
                      PRODUTO.CDARVPROD LIKE PC.CDARVPROD || '%')
           GROUP BY
              FILIAL.CDREGIAO,
              ITEMSOLI.CDFILSOLI,
              ITEMSOLI.CDPRODUTO,
              ITEMSOLI.DTPROGENTR
           )LOOP

          SELECT
             NVL(MAX(PRODFILI.IDPRODATIV), 'A')
          INTO
             V_IDPRODATIV
          FROM
             PRODFILI
          WHERE
             PRODFILI.CDFILIAL  = C_ITEMSOLI.CDFILSOLI AND
             PRODFILI.CDPRODUTO = C_ITEMSOLI.CDPRODUTO;

          IF V_IDPRODATIV = 'A' THEN
             V_CTPRODCMP := 0;
             SELECT
                COUNT(*)
             INTO
                V_CTPRODCMP
             FROM
                PRODCMPFILI_TMP PRODCMPFILI,
                PRODUTO,
                PRODUTO P
             WHERE
                P.CDPRODUTO = C_ITEMSOLI.CDPRODUTO AND
                PRODCMPFILI.CDPRODUTO = PRODUTO.CDPRODUTO AND
                PRODCMPFILI.CDFILIAL = C_ITEMSOLI.CDFILSOLI AND
                PRODCMPFILI.CDFILIAL <> P_FILIPROC AND
                PRODCMPFILI.NRSEQAPUR = P_NRSEQAPUR AND
                P.CDARVPROD LIKE PRODUTO.CDARVPROD||'%' AND
                PRODUTO.CDARVPROD > (SELECT
                                        DECODE(MAX(PR.CDARVPROD), NULL, '0', MAX(PR.CDARVPROD))
                                     FROM
                                        PRODNCMP,
                                        PRODUTO PR
                                     WHERE
                                        PRODNCMP.CDPRODUTO = PR.CDPRODUTO AND
                                        P.CDARVPROD LIKE PR.CDARVPROD||'%' AND
                                        PRODNCMP.CDFILIAL = C_ITEMSOLI.CDFILSOLI);
             IF V_CTPRODCMP = 0 THEN
                V_CTPRODCMP := 1;
             ELSE
                V_CTPRODCMP := 0;
             END IF;
             IF V_CTPRODCMP > 0 THEN
               V_QTACOMPRAR := C_ITEMSOLI.QTDEACOMP;
               V_QTDECOMP := 0;
               BEGIN
           --      DBMS_OUTPUT.PUT_LINE('AF');
                 SELECT
                    SUM(ITEMAUTF.QTPROGENTAF) INTO V_QTDECOMP  /* QTDE CONVERTIDA PARA ESTOQUE */
                 FROM
                    AUTOFORNE, ITEMAUTF, ITMAPURPREC
                 WHERE
                    (AUTOFORNE.CDFILDEST    = ITEMAUTF.CDFILDEST)   AND
                    (AUTOFORNE.CDFILLANC    = ITEMAUTF.CDFILLANC)   AND
                    (AUTOFORNE.NRAUTOFORN   = ITEMAUTF.NRAUTOFORN) AND
                    (AUTOFORNE.IDAUTOFORNEX = 'N')   AND
                     DECODE(AUTOFORNE.IDBAIXAAF, NULL, '0', AUTOFORNE.IDBAIXAAF) <> '5' AND
                    (ITEMAUTF.CDFILDEST     =  C_ITEMSOLI.CDFILSOLI)  AND
                    (ITEMAUTF.CDPRODUTO     =  C_ITEMSOLI.CDPRODUTO)  AND
                    (ITEMAUTF.DTENTRITMSOL  =  C_ITEMSOLI.DTPROGENTR) AND
                    (ITEMAUTF.CDFILDEST     = ITMAPURPREC.CDFILIAP)                      AND
                    (ITEMAUTF.CDMARCA       = ITMAPURPREC.CDMARCITMAP)                   AND
                    (ITEMAUTF.CDPRODUTO     = ITMAPURPREC.CDPRODITMAP)                   AND
                    (ITEMAUTF.DTPROGENTAF   = ITMAPURPREC.DTENTRAPUT)                    AND
                    (AUTOFORNE.CDFORNECED   = ITMAPURPREC.CDFORNITMAP)                   AND
                    (AUTOFORNE.NRSEQAPURAF  = ITMAPURPREC.NRSEQITMAP)                   AND
                    (NVL(ITMAPURPREC.NRCOMPRA, P_NRCOMPRA) = P_NRCOMPRA)                AND
                    (ITMAPURPREC.NRCOMPRA IS NOT NULL)
                 GROUP BY
                    ITEMAUTF.CDFILDEST,
                    ITEMAUTF.DTENTRITMSOL,
                    ITEMAUTF.CDPRODUTO;
               EXCEPTION
                 WHEN OTHERS THEN
                   V_QTDECOMP := 0;
               END;
               V_QTACOMPRAR := V_QTACOMPRAR - V_QTDECOMP;

               IF TRUNC(V_QTACOMPRAR,3) > 0 THEN
                  FOR C_GRAVA IN (
                  SELECT /*+ INDEX(ITEMCOLE ITEMCOLE_01)*/
                     ITEMCOLE.CDFILIAL,
                     ITEMCOLE.CDPRODUTO,
                     PRODUTO.VRFATOCONV,
                     ITEMCOLE.NRCOLEPRECO,
                     ITEMCOLE.CDFORNECED,
                     ITEMCOLE.CDREGIAO,
                     ITEMCOLE.CDMARCA,
                     ITEMCOLE.CDTIPCOB,
                     ITEMCOLE.CDFORMPGTO,
                     ITEMCOLE.IDUTDIAPGCOL,
                     ITEMCOLE.IDTPFOPGTCOL,
                     ITEMCOLE.IDTIPFREITM,
                     ITEMCOLE.NRPARCPGTCOL,
                     ITEMCOLE.CDSEGMARCCOL,
                     ITEMCOLE.VRPRECUNIITM,
                     ITEMCOLE.VRPERDESITM,
                     ITEMCOLE.NRDIAPGFXCOL,
                     ITEMCOLE.VRPRECECOITM,
                     ITEMCOLE.VRPRECOITMPI,
                     ITEMCOLE.IDITMLISPREC,
                     ITEMCOLE.NRSEQPRELIST
                   FROM
                     ITEMCOLE,
                     PRODUTO,
                     FORNECEDOR,
                     COLETAPR
                   WHERE
                     COLETAPR.CDFILIAL      = P_CDCENTCMP              AND
                     COLETAPR.CDOPERADOR    = P_CDCOMPRADOR            AND
                     COLETAPR.NRCOMPRA      = P_NRCOMPRA               AND
                     COLETAPR.CDFILIAL      = ITEMCOLE.CDFILIAL        AND
                     COLETAPR.NRCOLEPRECO   = ITEMCOLE.NRCOLEPRECO     AND
                     C_ITEMSOLI.CDPRODUTO   = ITEMCOLE.CDPRODUTO       AND
                     ITEMCOLE.CDPRODUTO     = PRODUTO.CDPRODUTO        AND
                     ITEMCOLE.VRPRECUNIITM <> 0                        AND
                     ITEMCOLE.CDREGIAO      = C_ITEMSOLI.CDREGIAO      AND
                     (C_ITEMSOLI.DTPROGENTR BETWEEN ITEMCOLE.DTINIVALITM AND ITEMCOLE.DTFINVALITM) AND
                     FORNECEDOR.CDFORNECED  = ITEMCOLE.CDFORNECED      AND
                     FORNECEDOR.IDSITUCADA  = 'A'                      AND
                     FORNECEDOR.IDTIPOFORN <> 'A'                      AND
                     ((V_IDUTISTATCOT = 'N') OR (NVL(COLETAPR.IDSITUCOLETA, 'C') = 'C')) AND

                     NOT EXISTS
                      (SELECT
                          1
                       FROM
                         REFOREG
                       WHERE
                         REFOREG.CDREGIAO   = C_ITEMSOLI.CDREGIAO AND
                         REFOREG.CDFORNECED = ITEMCOLE.CDFORNECED) AND

                     NOT EXISTS
                     (SELECT
                         1
                      FROM
                         QFOPRODFORN,
                         PARASUPRI
                      WHERE
                        PARASUPRI.CDFILIAL = P_CDCENTCMP  AND
                        (QFOPRODFORN.CDPRODUTO = PRODUTO.CDPRODUTO) AND
                        (QFOPRODFORN.CDFORNECED= ITEMCOLE.CDFORNECED) AND
                        ((QFOPRODFORN.IDFORNAPROV = 'N' AND QFOPRODFORN.IDFORNAUTOR = 'N') OR
                         ((QFOPRODFORN.IDFORNAPROV = 'S') AND
                            ((PARASUPRI.IDULTIDTVALQ = 'M' AND
                              COLETAPR.DTCOLEPREC > LAST_DAY(QFOPRODFORN.DTVALPRFORN)) OR
                             (PARASUPRI.IDULTIDTVALQ = 'D' AND
                              COLETAPR.DTCOLEPREC > QFOPRODFORN.DTVALPRFORN)) ) )) AND

                     NOT EXISTS
                       (SELECT
                           1
                        FROM
                          QFOMARPROD, PARASUPRI
                        WHERE
                         (PARASUPRI.CDFILIAL = P_CDCENTCMP)            AND
                         (QFOMARPROD.CDPRODUTO = PRODUTO.CDPRODUTO) AND
                         (QFOMARPROD.CDMARCA   = ITEMCOLE.CDMARCA)     AND
                         ((QFOMARPROD.IDAPRMARPRO = 'N' AND QFOMARPROD.IDAUTMARPRO = 'N') OR
                          ((QFOMARPROD.IDAPRMARPRO = 'S') AND
                             ((PARASUPRI.IDULTIDTVALQ = 'M' AND
                               COLETAPR.DTCOLEPREC > LAST_DAY(QFOMARPROD.DTVALAPROVA)) OR
                              (PARASUPRI.IDULTIDTVALQ = 'D' AND
                               COLETAPR.DTCOLEPREC > QFOMARPROD.DTVALAPROVA)) ) )) AND

                     EXISTS
                       (SELECT
                           1
                        FROM
                          QFOMARPROD
                        WHERE
                          QFOMARPROD.CDPRODUTO = PRODUTO.CDPRODUTO AND
                          QFOMARPROD.CDMARCA   = ITEMCOLE.CDMARCA

                        UNION

                        SELECT
                           1
                        FROM
                          PARASUPRI
                        WHERE
                          PARASUPRI.CDFILIAL    = P_CDCENTCMP AND
                          (PARASUPRI.IDMARSEMQUA = 'N' OR PARASUPRI.IDMARSEMQUA IS NULL)) AND

                     NOT EXISTS
                       (SELECT 1
                        FROM QUALIFICACAO, PARASUPRI
                        WHERE (FORNECEDOR.CDQUALIF       = QUALIFICACAO.CDQUALIF) AND
                              (PARASUPRI.CDFILIAL        = P_CDCENTCMP)           AND
                              (FORNECEDOR.IDFORNAUTO     = 'N')                   AND
                              ((QUALIFICACAO.IDPERCOTCMP = '2')                   OR
                               ((PARASUPRI.IDULTIDTVALQ  = 'D'                    AND
                                 COLETAPR.DTCOLEPREC > FORNECEDOR.DTVALQUALIF)       OR
                               (PARASUPRI.IDULTIDTVALQ = 'M'                      AND
                                COLETAPR.DTCOLEPREC > LAST_DAY(FORNECEDOR.DTVALQUALIF))))) AND

                     NOT EXISTS /* Tirando fornecedores que no atendam s filiais */
                      (SELECT
                          1
                       FROM
                         REFORFIL
                       WHERE
                         REFORFIL.CDFILIAL   = C_ITEMSOLI.CDFILSOLI AND
                         REFORFIL.CDPERIENTR IS NULL AND
                         REFORFIL.CDFORNECED = ITEMCOLE.CDFORNECED ))
                    LOOP
                      V_CTIMPOSTO := NULL;
                      V_CONCKEY   := NULL;
                      IF V_IDSEPAFIMP = 'S' THEN
                         SELECT
                            COUNT(*)
                         INTO
                            V_CTIMPOSTO
                         FROM
                            IMPCOLET
                         WHERE
                            CDFILIAL    = C_GRAVA.CDFILIAL    AND
                            NRCOLEPRECO = C_GRAVA.NRCOLEPRECO AND
                            CDMARCA     = C_GRAVA.CDMARCA     AND
                            CDREGIAO    = C_GRAVA.CDREGIAO    AND
                            CDFORNECED  = C_GRAVA.CDFORNECED  AND
                            CDPRODUTO   = C_GRAVA.CDPRODUTO;
                         IF V_CTIMPOSTO = 0 THEN
                            V_CONCKEY := '';
                         ELSE
                            IF V_CTIMPOSTO = 1 THEN
                               SELECT DISTINCT
                                  CDIMPOSTO
                               INTO
                                  V_CONCKEY
                               FROM
                                  IMPCOLET
                               WHERE
                                  CDFILIAL    = C_GRAVA.CDFILIAL    AND
                                  NRCOLEPRECO = C_GRAVA.NRCOLEPRECO AND
                                  CDMARCA     = C_GRAVA.CDMARCA     AND
                                  CDREGIAO    = C_GRAVA.CDREGIAO    AND
                                  CDFORNECED  = C_GRAVA.CDFORNECED  AND
                                  CDPRODUTO   = C_GRAVA.CDPRODUTO;
                            ELSE
                               IF V_CTIMPOSTO > 1 THEN
                                  V_CONCKEY := '*';
                               END IF;
                            END IF;
                         END IF;
                      END IF;
                      V_EMITENTE  := EMITENTE(C_ITEMSOLI.CDFILSOLI, C_GRAVA.CDPRODUTO, C_GRAVA.CDFORNECED);
                      V_CDEMPRESA := SUBSTR(V_EMITENTE, 3, 2);
                      V_CONCKEY   := V_CONCKEY||C_GRAVA.CDFILIAL || C_GRAVA.CDFORNECED ||SUBSTR(V_EMITENTE, 3, 2)||
                                     C_GRAVA.IDTPFOPGTCOL ||
                                     C_GRAVA.CDTIPCOB     || C_GRAVA.IDTIPFREITM  ||
                                     C_GRAVA.CDFORMPGTO   || C_GRAVA.NRPARCPGTCOL ||
                                     C_GRAVA.NRDIAPGFXCOL || C_GRAVA.IDUTDIAPGCOL ||SUBSTR(V_EMITENTE, 1, 1);
                      V_IDTIPEMIT := SUBSTR(V_EMITENTE, 1, 1);
                      V_DSPZOPGTCONC := CONCAT_PZO_PAGTO (C_GRAVA.CDFILIAL,   C_GRAVA.NRCOLEPRECO,
                                                          C_GRAVA.CDFORNECED, C_GRAVA.CDPRODUTO,
                                                          C_GRAVA.CDMARCA,    C_GRAVA.CDREGIAO);
                      SELECT
                         DECODE(MAX(VRARREDCMP), NULL, 0, MAX(VRARREDCMP)) INTO V_VRARREDCMP
                      FROM
                         PRODUTO
                      WHERE
                         CDPRODUTO = C_GRAVA.CDPRODUTO;

                      V_QTACOMPRAR_AUX := V_QTACOMPRAR; /* CONVERTE PARA UNIDADE DE COMPRA */
                      IF (MOD(V_QTACOMPRAR_AUX, V_VRARREDCMP) <> 0) AND V_VRARREDCMP > 0 THEN
                         V_QTACOMPRAR_AUX := CEIL(V_QTACOMPRAR_AUX / V_VRARREDCMP) * V_VRARREDCMP;
                      END IF;

                      V_IDAFOPERLOG := 'X';
                      SELECT
                        DECODE(MAX('2'), NULL, 'X', MAX('2')) INTO V_IDAFOPERLOG
                      FROM
                        PARAMPRODSUP
                      WHERE
                         CDFILIAL     = C_ITEMSOLI.CDFILSOLI AND
                         CDPRODUTO    = C_GRAVA.CDPRODUTO         AND
                         CDFILIOPELOG IS NOT NULL;

                      V_IDPRODWEB := 'N';
                      SELECT
                        DECODE(MAX(PARAMPRODSUP.IDPRODWEB), NULL, 'N', MAX(PARAMPRODSUP.IDPRODWEB)) INTO V_IDPRODWEB
                      FROM
                        PARAMPRODSUP
                      WHERE
                         CDFILIAL   = C_ITEMSOLI.CDFILSOLI AND
                         CDPRODUTO  = C_GRAVA.CDPRODUTO         AND
                         CDFORNECED = C_GRAVA.CDFORNECED;

                      SELECT
                         MAX(CDFILIOPELOG) INTO V_CDFILIOPELOG
                      FROM
                        PARAMPRODSUP
                      WHERE
                         CDFILIAL     = C_ITEMSOLI.CDFILSOLI AND
                         CDPRODUTO    = C_GRAVA.CDPRODUTO;
                      IF V_CDFILIOPELOG IS NULL THEN
                         V_CDFILIOPELOG := 'OL_NULL';
                      END IF;

                      INSERT INTO ITMAPURPREC
                      (CDCENTITMAP,  NRSEQITMAP,   CDFILIAP,
                       DTENTRAPUT,   CDPRODITMAP,  NRCOLEITMAP,
                       CDFORNITMAP,  CDREGITMAP,   CDMARCITMAP,
                       QTSOLACOMP,   QTACOMP,      CDTIPCOBAP,
                       CDEMPRESAAP,  CDFORMPGTOAP, IDULTDIAPGTAF,
                       CONCKEYAP,    IDTPFORPGTAP, IDTIPOEMITAP,
                       IDTIPOFRETAP, NRPARCPGTOAP, CDSEGMARCCOL,
                       VRPRECUNIAP,  VRPERDESIAP,  NRDIAPGFIAP,
                       DSPZOPGTCOAP, VRPRECECOAP,  VRPRECONPIAP,
                       IDITMLISPRAP, NRLISTAITMAP, NRCOMPRA)
                      VALUES(P_CDCENTCMP,
                             P_NRSEQAPUR,
                             C_ITEMSOLI.CDFILSOLI,
                             C_ITEMSOLI.DTPROGENTR,
                             C_GRAVA.CDPRODUTO,
                             C_GRAVA.NRCOLEPRECO,
                             C_GRAVA.CDFORNECED,
                             C_GRAVA.CDREGIAO,
                             C_GRAVA.CDMARCA,
                             V_QTACOMPRAR_AUX,
                             V_QTACOMPRAR_AUX,
                             C_GRAVA.CDTIPCOB,
                             V_CDEMPRESA,
                             C_GRAVA.CDFORMPGTO,
                             C_GRAVA.IDUTDIAPGCOL,
                             V_CONCKEY||V_CDFILIOPELOG||V_IDPRODWEB||V_IDAFOPERLOG,
                             C_GRAVA.IDTPFOPGTCOL,
                             V_IDTIPEMIT,
                             C_GRAVA.IDTIPFREITM,
                             C_GRAVA.NRPARCPGTCOL,
                             C_GRAVA.CDSEGMARCCOL,
                             C_GRAVA.VRPRECUNIITM,
                             C_GRAVA.VRPERDESITM,
                             C_GRAVA.NRDIAPGFXCOL,
                             V_DSPZOPGTCONC,
                             C_GRAVA.VRPRECECOITM,
                             C_GRAVA.VRPRECOITMPI,
                             C_GRAVA.IDITMLISPREC,
                             C_GRAVA.NRSEQPRELIST,
                             P_NRCOMPRA);

                      IF SQL%ROWCOUNT > 0 THEN
                         P_ROWSAFFECT := 'S';
                         /*Exclui gerentes quando no houver aprovao de itens de solicitao de compras por gerentes*/
                         IF NVL(V_CDFILIAL, 'XXXX') <> C_ITEMSOLI.CDFILSOLI THEN
                            SELECT MAX(PARCMPSUP.CDFILIAL)
                              INTO V_CDFILIAL_PARAM
                              FROM PARCMPSUP, PARASUPRI, FILIAL
                             WHERE PARCMPSUP.CDFILIAL = FILIAL.CDFILIAL
                               AND PARASUPRI.CDFILIAL = NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL)
                               AND NVL(PARCMPSUP.IDUTAPROVSOL, 'N')    = 'S'
                               AND NVL(PARASUPRI.IDULTDESTSOL, 'N')    = 'S'
                               AND NVL(PARASUPRI.IDEXIGAPRGERCMP, 'N') = 'S'
                               AND PARCMPSUP.CDSUBGRPROD IS NOT NULL
                               AND FILIAL.CDFILIAL = C_ITEMSOLI.CDFILSOLI;
                            IF V_CDFILIAL_PARAM IS NOT NULL THEN
                               DELETE
                                 FROM APROVCOMPRA
                                WHERE NRCOMPRA = P_NRCOMPRA;
                               UPDATE COMPRA
                                  SET IDSITUCOMPRA = '8'
                                WHERE NRCOMPRA = P_NRCOMPRA;
                            END IF;
                            V_CDFILIAL := C_ITEMSOLI.CDFILSOLI;
                         END IF;
                      END IF;
                    END LOOP;
               END IF;
               COMMIT;
               V_QTACOMPRAR := 0;
             END IF;
          END IF;
        END LOOP;
     END IF;
     DELETE PRODCMPFILI_TMP WHERE NRSEQAPUR = P_NRSEQAPUR;
  END LOOP;
  IF P_ROWSAFFECT <> 'S' THEN
     DELETE
     FROM
        APURPRECO
     WHERE
         (CDFILCENTCMP = P_CDCENTCMP) AND
         (NRAPURPREC   = P_NRSEQAPUR);
  END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('APURA_COMPRA','5.40.000'); END;
/


