--- ====================================================================
--                  PROCEDIMENTO PARA ATUALIZAR ESTOQUE
--                  ------------ ---- --------- -------
--
--  PARMETROS: P_FILIMOVI   = CDIGO DA FILIAL A SER CONSIDERADA.
--              P_DTINICIAL  = DATA INICIAL PARA CLCULO DE ESTOQUE.
--              P_DTFINAL    = DATA FINAL PARA CLCULO DE ESTOQUE.
--              P_FILILANCTO = CDIGO DA FILIAL DE LANAMENTO.
--              P_NRLANCTO   = NMERO DE UM LANAMENTO (OPCIONAL).
--              P_CDPRODUTO  = CDIGO DO PRODUTO A SER EVOLUDO (OPCIONAL).
--
-- C:\Web_470\SQL\END_CONV\SQLSERVER\4002_ESTSTP_ATUALIZA_ESTOQUE.SQL
--
-- ====================================================================

IF EXISTS (SELECT
              *
           FROM
              SYSOBJECTS O, SYSUSERS U
           WHERE
              O.NAME = 'ATUALIZA_ESTOQUE' AND
              TYPE = 'P' 		  AND
              U.UID = O.UID               AND
              U.NAME = USER)

DROP PROCEDURE ATUALIZA_ESTOQUE
GO

CREATE PROCEDURE ATUALIZA_ESTOQUE
                 @P_FILIMOVI   VARCHAR(04),
                 @P_DTINICIAL  DATETIME,
                 @P_DTFINAL    DATETIME,
                 @P_FILILANCTO VARCHAR(04),
                 @P_NRLANCTO   VARCHAR(10) = NULL
AS
   DECLARE @V_FILIAUX      VARCHAR(04);
   DECLARE @V_IDESTONEG    VARCHAR(04);
   DECLARE @V_DTINICIAL    DATETIME;
   DECLARE @V_DTINICAUX    DATETIME;
   DECLARE @V_DTINICEST    DATETIME;
   DECLARE @V_DTINICPOS    DATETIME;
   DECLARE @V_DTFINAL      DATETIME;
   DECLARE @V_COUNTPOS     NUMERIC(15,5);
   DECLARE @V_QTDEESTO     NUMERIC(15,5);
   DECLARE @V_VALRESTO     NUMERIC(15,5);
   DECLARE @V_VALRBRUT     NUMERIC(15,5);
   DECLARE @V_VALRESTOM1   NUMERIC(15,5);
   DECLARE @V_VALRBRUTM1   NUMERIC(15,5);
   DECLARE @V_VALRESTOM2   NUMERIC(15,5);
   DECLARE @V_VALRBRUTM2   NUMERIC(15,5);

   DECLARE @V_QTDEANTE     NUMERIC(15,5);
   DECLARE @V_VRESTANT     NUMERIC(15,5);
   DECLARE @V_VRBRUANT     NUMERIC(15,5);
   DECLARE @V_VRESTANTM1   NUMERIC(15,5);
   DECLARE @V_VRBRUANTM1   NUMERIC(15,5);
   DECLARE @V_VRESTANTM2   NUMERIC(15,5);
   DECLARE @V_VRBRUANTM2   NUMERIC(15,5);

   DECLARE @V_QTDEESTOPOS   NUMERIC(15,5);
   DECLARE @V_VALRESTOPOS   NUMERIC(15,5);
   DECLARE @V_VALRBRUTPOS   NUMERIC(15,5);
   DECLARE @V_QTDEANTEPOS   NUMERIC(15,5);
   DECLARE @V_VRESTANTPOS   NUMERIC(15,5);
   DECLARE @V_VRBRUANTPOS   NUMERIC(15,5);
   DECLARE @V_VALRESTOPOSM1 NUMERIC(15,5);
   DECLARE @V_VALRBRUTPOSM1 NUMERIC(15,5);
   DECLARE @V_VALRESTOPOSM2 NUMERIC(15,5);
   DECLARE @V_VALRBRUTPOSM2 NUMERIC(15,5);
   DECLARE @V_VRESTANTPOSM1 NUMERIC(15,5);
   DECLARE @V_VRBRUANTPOSM1 NUMERIC(15,5);
   DECLARE @V_VRESTANTPOSM2 NUMERIC(15,5);
   DECLARE @V_VRBRUANTPOSM2 NUMERIC(15,5);

   DECLARE @V_DTSALDO      DATETIME;
   DECLARE @V_EXISMOV      VARCHAR(01);
   DECLARE @V_POSIZERO     VARCHAR(01);
   DECLARE @V_DTPOSIESTQ   DATETIME;

   /* VARIVEIS DO CURSOR C_PRODUTO */
   DECLARE @V_CDFILIAL     VARCHAR(04);
   DECLARE @V_CDALMOXARIFE VARCHAR(06);
   DECLARE @V_CDLOCALESTOQ VARCHAR(06);
   DECLARE @V_NRLOTEESTQ   VARCHAR(20);
   DECLARE @V_NRSUBLOTE    VARCHAR(04);
   DECLARE @V_CDPRODUTO    VARCHAR(10);
   DECLARE @V_DTRECALCEST  DATETIME;

   /* VARIVEIS DO CURSOR C_LANCTOEST */
   DECLARE @V_IDTIPOMOVI   VARCHAR(01);
   DECLARE @V_DTLANCMOVI   DATETIME;
   DECLARE @V_VRLANCTOEST  NUMERIC(15,5);
   DECLARE @V_VRLANCTOBRUT NUMERIC(15,5);
   DECLARE @V_QTLANCTOEST  NUMERIC(15,5);
   DECLARE @V_IDALTCMEDMV  VARCHAR(01);
   DECLARE @V_CDFILILANC   VARCHAR(04);
   DECLARE @V_CURLANCESTQ  VARCHAR(10);

   DECLARE @V_NRLANCESTQ   VARCHAR(14);
   DECLARE @V_DTCUSTCALC   DATETIME;
   DECLARE @V_DTAUXILIAR   DATETIME;

   DECLARE @V_CDINDICEMF    VARCHAR(04);
   DECLARE @V_CDINDICEMF2   VARCHAR(04);

   DECLARE @V_CDTPINDICE    VARCHAR(01);
   DECLARE @V_IDPERVALOR    VARCHAR(01);
   DECLARE @V_CDTPINDICE2   VARCHAR(01);
   DECLARE @V_IDPERVALOR2   VARCHAR(01);
   DECLARE @V_VRINDICE1     NUMERIC;
   DECLARE @V_VRINDICE2     NUMERIC;
   DECLARE @V_QTRESPRODPED  NUMERIC;

   DECLARE @V_MENSAGEM      VARCHAR(200);
   DECLARE @V_CDPROD        VARCHAR(10);
   DECLARE @V_CUSTPROD      NUMERIC(15,5);
   DECLARE @V_MOVNEG        VARCHAR(01);
/*VARIVEIS PARA CALCULO DO CUSTO LOGISTICO*/

   DECLARE @V_VRCLOGDIAANT    NUMERIC(15,5);
   DECLARE @V_VRSEGUDIAANT    NUMERIC(15,5);
   DECLARE @V_VRCUSTOLOG      NUMERIC(15,5);
   DECLARE @V_VRCUSTOSEG      NUMERIC(15,5);
   DECLARE @V_VRCLOGDIAAM1    NUMERIC(15,5);
   DECLARE @V_VRCLOGDIAAM2    NUMERIC(15,5);
   DECLARE @V_VRSEGUDIAAM1    NUMERIC(15,5);
   DECLARE @V_VRSEGUDIAAM2    NUMERIC(15,5);
   DECLARE @V_VRCLOGDIAM1     NUMERIC(15,5);
   DECLARE @V_VRCLOGDIAM2     NUMERIC(15,5);
   DECLARE @V_VRSEGUDIAM1     NUMERIC(15,5);
   DECLARE @V_VRSEGUDIAM2     NUMERIC(15,5);
   DECLARE @V_VRCUSTLOGLAN    NUMERIC(15,5);
   DECLARE @V_VRSEGULOGLAN    NUMERIC(15,5);
   DECLARE @V_VRCUSTOLOGPOS   NUMERIC(15,5);
   DECLARE @V_VRCUSTOSEGPOS   NUMERIC(15,5);

   DECLARE @V_UTILLOTE        VARCHAR(1);
   DECLARE @V_UTILALMO        VARCHAR(1);

   DECLARE @V_NRLISTA         VARCHAR(20);

   DECLARE @V_NRSEQUITEM      VARCHAR(20);
   
   DECLARE @V_QTESTOQDIAE      NUMERIC(15,5);
   DECLARE @V_VRESTOQDIAE      NUMERIC(15,5);
   DECLARE @V_VRESTOQDIAM1E    NUMERIC(15,5);
   DECLARE @V_VRESTOQDIAM2E    NUMERIC(15,5);
   DECLARE @V_QTESTOQANTE      NUMERIC(15,5);
   DECLARE @V_DTCUSTANTE       DATETIME;
   DECLARE @V_VRESTOQANTE      NUMERIC(15,5);
   DECLARE @V_VRESTOQANTM1E    NUMERIC(15,5);
   DECLARE @V_VRESTOQANTM2E    NUMERIC(15,5);
   DECLARE @V_VRESTOQBRUTE     NUMERIC(15,5);
   DECLARE @V_VRESTOQBRUM1E    NUMERIC(15,5);
   DECLARE @V_VRESTOQBRUM2E    NUMERIC(15,5);
   DECLARE @V_VRBRUTOANTE      NUMERIC(15,5);
   DECLARE @V_VRBRUTOANTM1E    NUMERIC(15,5);
   DECLARE @V_VRBRUTOANTM2E    NUMERIC(15,5);
   DECLARE @V_IDPOSIZEROE      VARCHAR(1);
   DECLARE @V_VRCLOGDIAE       NUMERIC(15,5);
   DECLARE @V_VRCLOGDIAANTE    NUMERIC(15,5);
   DECLARE @V_VRCLOGDIAM1E     NUMERIC(15,5);
   DECLARE @V_VRCLOGDIAAM1E    NUMERIC(15,5);
   DECLARE @V_VRCLOGDIAM2E     NUMERIC(15,5);
   DECLARE @V_VRCLOGDIAAM2E    NUMERIC(15,5);
   DECLARE @V_VRSEGUDIAE       NUMERIC(15,5);
   DECLARE @V_VRSEGUDIAANTE    NUMERIC(15,5);
   DECLARE @V_VRSEGUDIAM1E     NUMERIC(15,5);
   DECLARE @V_VRSEGUDIAAM1E    NUMERIC(15,5);
   DECLARE @V_VRSEGUDIAM2E     NUMERIC(15,5);
   DECLARE @V_VRSEGUDIAAM2E    NUMERIC(15,5);

   DECLARE @V_CDPRODPOSEST     VARCHAR(10);
   DECLARE @V_DTPOSICAO        DATETIME;
   DECLARE @V_DTULTMOVIMEN     DATETIME;
   DECLARE @V_COUNT            NUMERIC;

   DECLARE @V_DTENTRSAIDANT    DATETIME;  /*Data anterior da NF*/
   DECLARE @V_DTLANCMOVANT     DATETIME;  /*Data anterior do Item na Itlanctoest*/
   DECLARE @V_DATAPOS          DATETIME; /*Variavel auxiliar*/

   DECLARE @V_CDPRODLIST       VARCHAR(20);
   DECLARE @V_DTPOSESTPROD     DATETIME;
   DECLARE @V_CDPRODUTOATU     VARCHAR(20);
   DECLARE @V_CDTIPOOPER       VARCHAR(2);
   DECLARE @V_QTRESPRODPEDOL   NUMERIC;
   DECLARE @V_IDNFDEVOOL       VARCHAR(1);

   DECLARE @V_DTPOSESTCONS     DATETIME;
   /* Fator de conversao variavel */
   DECLARE @V_NRSEQUITEMVAR   VARCHAR(4);
   DECLARE @V_CDFILIMOVIVAR   VARCHAR(4);
   DECLARE @V_NRLOTEESTQVAR   VARCHAR(20);
   DECLARE @V_NRSUBLOTEVAR    VARCHAR(4);
   DECLARE @V_CDPRODMOVIVAR   VARCHAR(10);
   DECLARE @V_QTTOTLANCTOVAR  NUMERIC(15,5);
   DECLARE @V_VRLANCTOESTVAR  NUMERIC(15,5);
   DECLARE @V_VRTOTLANCTOVAR  NUMERIC(15,5);
   DECLARE @V_VRFATOCONVVAR   NUMERIC(15,5);
   DECLARE @V_QTLANCTESTVAR   NUMERIC(15,5);
   DECLARE @V_VRLANCTVAR      NUMERIC(15,5);
   DECLARE @V_VRLANCTOBRUTVAR NUMERIC(15,5);
   DECLARE @V_DIFERENCA       NUMERIC(15,5);
   DECLARE @V_IDTIPOMOVIVAR   VARCHAR(01);
BEGIN

   SET @V_CDTPINDICE    = NULL;
   SET @V_IDPERVALOR    = NULL;
   SET @V_CDINDICEMF    = NULL;
   SET @V_CDTPINDICE2   = NULL;
   SET @V_IDPERVALOR2   = NULL;
   SET @V_CDINDICEMF2   = NULL;
   SET @V_DTRECALCEST   = NULL;
   SET @V_FILIAUX       = NULL;
   SET @V_DTINICEST     = NULL;
   SET @V_DTINICPOS     = NULL;
   SET @V_DTFINAL       = NULL;
   SET @V_QTDEESTOPOS   = 0;
   SET @V_VALRESTOPOS   = 0;
   SET @V_VALRBRUTPOS   = 0;
   SET @V_VALRESTOPOSM1 = 0;
   SET @V_VALRBRUTPOSM1 = 0;
   SET @V_VALRESTOPOSM2 = 0;
   SET @V_VALRBRUTPOSM2 = 0;
   SET @V_QTDEANTEPOS   = 0;
   SET @V_VRESTANTPOS   = 0;
   SET @V_VRBRUANTPOS   = 0;
   SET @V_VRESTANTPOSM1 = 0;
   SET @V_VRBRUANTPOSM1 = 0;
   SET @V_VRESTANTPOSM2 = 0;
   SET @V_VRBRUANTPOSM2 = 0;
   SET @V_DTAUXILIAR    = NULL;
   SET @V_VRINDICE1     = 0;
   SET @V_VRINDICE2     = 0;
   SET @V_COUNTPOS      = 0;
   SET @V_IDESTONEG     = NULL;
   SET @V_QTDEESTO      = 0;
   SET @V_VALRESTO      = 0;
   SET @V_VALRBRUT      = 0;
   SET @V_VALRESTOM1    = 0;
   SET @V_VALRESTOM2    = 0;
   SET @V_DTPOSIESTQ    = NULL;
   SET @V_QTRESPRODPED  = 0;
   SET @V_COUNTPOS      = 0;
   SET @V_VRCLOGDIAANT  = 0;
   SET @V_VRSEGUDIAANT  = 0;
   SET @V_VRCUSTOLOG    = 0;
   SET @V_VRCUSTOSEG    = 0;
   SET @V_VRCLOGDIAAM1  = 0;
   SET @V_VRCLOGDIAAM2  = 0;
   SET @V_VRSEGUDIAAM1  = 0;
   SET @V_VRSEGUDIAAM2  = 0;
   SET @V_VRCLOGDIAM1   = 0;
   SET @V_VRCLOGDIAM2   = 0;
   SET @V_VRSEGUDIAM1   = 0;
   SET @V_VRSEGUDIAM2   = 0;
   SET @V_VRCUSTLOGLAN  = 0;
   SET @V_VRSEGULOGLAN  = 0;
   SET @V_VRFATOCONVVAR = 1;
   SET @V_QTLANCTESTVAR = 1;

   SELECT @V_CDTPINDICE = MAX(ISNULL(CDTPINDICE,NULL)),
          @V_IDPERVALOR = MAX(ISNULL(IDPERVALOR,NULL)),
          @V_CDINDICEMF  = MAX(ISNULL(CDINDICEMF,NULL)),
          @V_CDTPINDICE2 = MAX(ISNULL(CDTPINDICE2,NULL)),
          @V_IDPERVALOR2 = MAX(ISNULL(IDPERVALOR2,NULL)),
          @V_CDINDICEMF2 = MAX(ISNULL(CDINDICEMF2,NULL))
   FROM PARAMGERAL;

   SET @V_CDPROD = 'X';

   SELECT @V_UTILLOTE = MAX(ISNULL(IDUTILLOTE,'N')),
          @V_UTILALMO = MAX(ISNULL(IDUTILALMOX,'N'))
   FROM PARAMFILIAL
   WHERE CDFILIAL = @P_FILIMOVI;

   /*Gera um nmero randomico para chave da tabela lista que recebe os itens
     atualizados, para posterior atualizao da POSESTCONS*/

   SELECT @V_NRLISTA = CAST(CAST(ABS(ROUND((RAND()* 1000000000),0)) AS INT) AS VARCHAR);

   DECLARE C_ITLANCTO CURSOR FOR
   SELECT IT.IDTIPOMOVI, IT.NRSEQUITEM, IT.CDFILIMOVI, IT.NRLOTEESTQ, IT.NRSUBLOTE, IT.CDPRODMOVI, 
          IT.QTTOTLANCTO, IT.VRTOTLANCTO, IT.VRLANCTOEST, IT.VRLANCTOBRUT
     FROM ITLANCTOEST IT, PRODUTO P, PRODFILI PF
    WHERE IT.CDPRODUTO  = P.CDPRODUTO
      AND P.CDPRODESTO  = PF.CDPRODUTO
      AND PF.CDFILIAL   = IT.CDFILIMOVI
      AND IT.CDFILIAL   = @P_FILILANCTO
      AND IT.NRLANCESTQ = @P_NRLANCTO
      AND PF.IDUTVRFTCONVVAR = 'S'
      /* IMPLANTAO, AJUSTE, ENTRADA E DEVOLUO */
      AND IT.IDTIPOMOVI IN ('0', '1', '2', '5');
   
   OPEN C_ITLANCTO;
   FETCH NEXT FROM C_ITLANCTO INTO @V_IDTIPOMOVIVAR, @V_NRSEQUITEMVAR, @V_CDFILIMOVIVAR, @V_NRLOTEESTQVAR, @V_NRSUBLOTEVAR, @V_CDPRODMOVIVAR, 
                                   @V_QTTOTLANCTOVAR, @V_VRTOTLANCTOVAR, @V_VRLANCTVAR, @V_VRLANCTOBRUTVAR;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      SET @V_DIFERENCA      = 0;
      SET @V_VRLANCTOESTVAR = 0;
      
      SELECT @V_VRFATOCONVVAR = VRFATOCONV
        FROM LOTE
       WHERE CDFILIAL   = @V_CDFILIMOVIVAR
         AND NRLOTEESTQ = @V_NRLOTEESTQVAR
         AND NRSUBLOTE  = @V_NRSUBLOTEVAR
         AND CDPRODUTO  = @V_CDPRODMOVIVAR;
      
      SET @V_QTLANCTESTVAR  = (@V_QTTOTLANCTOVAR * @V_VRFATOCONVVAR);
      
      IF ((@V_VRLANCTVAR > 0) AND (@V_QTLANCTESTVAR <> 0)) BEGIN
         SET @V_DIFERENCA      = (@V_VRLANCTOBRUTVAR / @V_VRLANCTVAR);
         SET @V_VRLANCTOESTVAR = (@V_VRTOTLANCTOVAR / @V_QTLANCTESTVAR);
      END;
     
      UPDATE ITLANCTOEST
         SET QTLANCTOEST  = @V_QTLANCTESTVAR,
             VRLANCTOEST  = @V_VRLANCTOESTVAR,
             VRLANCTOBRUT = (@V_VRLANCTOESTVAR * @V_DIFERENCA)
       WHERE CDFILIAL   = @P_FILILANCTO
         AND NRLANCESTQ = @P_NRLANCTO
         AND NRSEQUITEM = @V_NRSEQUITEMVAR;
   END;
   
   CLOSE C_ITLANCTO;
   DEALLOCATE C_ITLANCTO;

   /* LER OS PRODUTOS QUE SERO ATUALIZADOS */
   DECLARE C_PRODUTO CURSOR FOR
   SELECT M.CDFILIAL, M.CDALMOXARIFE, M.CDLOCALESTOQ,
          M.NRLOTEESTQ, M.NRSUBLOTE, M.CDPRODUTO
   FROM MOVILOTE M
   WHERE M.NRMOVILOTE   = @P_FILILANCTO + @P_NRLANCTO
   UNION
   SELECT M.CDFILIAL, M.CDALMOXARIFE, M.CDLOCALESTOQ,
          M.NRLOTEESTQ, M.NRSUBLOTE, M.CDPRODUTO
   FROM MOVILOTE M
   WHERE M.NRLANCTOORIG = @P_FILILANCTO + @P_NRLANCTO;

   OPEN C_PRODUTO;
   FETCH NEXT FROM C_PRODUTO INTO @V_CDFILIAL, @V_CDALMOXARIFE, @V_CDLOCALESTOQ,
                                  @V_NRLOTEESTQ, @V_NRSUBLOTE, @V_CDPRODUTO;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF (@V_CDPROD = 'X') BEGIN
         SET @V_CDPROD = @V_CDPRODUTO;

         INSERT INTO LISTA
           (NRLISTA, CDLISTA)
          (SELECT @V_NRLISTA, @V_CDPRODUTO
           WHERE
           NOT EXISTS
           (SELECT NRLISTA, @V_CDPRODUTO
           FROM LISTA
           WHERE NRLISTA = @V_NRLISTA  AND
                 CDLISTA = @V_CDPRODUTO));

      END;

      IF (@V_CDPROD <> @V_CDPRODUTO) BEGIN
         IF (ISNULL(@V_UTILALMO,'N') = 'S') OR  (ISNULL(@V_UTILLOTE, 'N') = 'S') BEGIN
            EXEC TEKNISA.ATUALIZA_ESTOQUE_CONS @P_FILIMOVI, @V_CDPROD, @P_DTINICIAL, @P_DTFINAL;
            SET @V_CDPROD = @V_CDPRODUTO;
         END
         ELSE BEGIN
            SET @V_CDPROD = @V_CDPRODUTO;
            INSERT INTO LISTA
              (NRLISTA, CDLISTA)
           (SELECT @V_NRLISTA, @V_CDPRODUTO
            WHERE
            NOT EXISTS
            (SELECT NRLISTA, @V_CDPRODUTO
            FROM LISTA
            WHERE NRLISTA = @V_NRLISTA  AND
                  CDLISTA = @V_CDPRODUTO));
         END;
      END;

      /* BLOQUEIA O PRODUTO PARA ATUALIZAO DO ESTOQUE */
      SELECT @V_DTRECALCEST = MAX(DTRECALCEST)
      FROM PRODLCESTOQ
      WHERE (CDFILIAL     = @V_CDFILIAL)     AND
            (CDALMOXARIFE = @V_CDALMOXARIFE) AND
            (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
            (CDPRODUTO    = @V_CDPRODUTO);

      IF NOT(@V_DTRECALCEST IS NULL) BEGIN
         /* BLOQUEIA O PRODUTO PARA ATUALIZAO DO ESTOQUE */
         SELECT @V_FILIAUX = CDFILIAL
         FROM PRODLCESTOQ WITH(UPDLOCK NOWAIT)
         WHERE (CDFILIAL     = @V_CDFILIAL)     AND
               (CDALMOXARIFE = @V_CDALMOXARIFE) AND
               (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
               (CDPRODUTO    = @V_CDPRODUTO)
      END;

      /* ATUALIZA AS DATAS INICIAL/FINAL PARA ATUALIZAR TODO PERODO */

      SELECT @V_DTINICEST = MIN(DTLANCMOVI)
      FROM ITLANCTOEST
      WHERE (CDFILIMOVI   = @V_CDFILIAL)     AND
            (CDALMOXARIFE = @V_CDALMOXARIFE) AND
            (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
            (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
            (NRSUBLOTE    = @V_NRSUBLOTE)    AND
            (CDPRODMOVI   = @V_CDPRODUTO);

      SELECT @V_DTINICPOS = MIN(DTPOSIESTQ)
      FROM POSESTDIA
      WHERE (CDFILIAL     = @V_CDFILIAL)     AND
            (CDALMOXARIFE = @V_CDALMOXARIFE) AND
            (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
            (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
            (NRSUBLOTE    = @V_NRSUBLOTE)    AND
            (CDPRODUTO    = @V_CDPRODUTO);

      /* DATA INICIAL */

      IF NOT(@V_DTRECALCEST IS NULL)     AND
         (@V_DTRECALCEST < @P_DTINICIAL) BEGIN
         SET @V_DTINICIAL = @V_DTRECALCEST;
      END
      ELSE BEGIN
         SET @V_DTINICIAL = @P_DTINICIAL;
      END;

      IF NOT(@V_DTINICEST IS NULL) OR
         NOT(@V_DTINICPOS IS NULL) BEGIN

         IF NOT(@V_DTINICEST IS NULL) BEGIN
            SET @V_DTINICAUX = @V_DTINICEST;
         END;

         IF NOT(@V_DTINICPOS IS NULL) BEGIN
            IF (@V_DTINICPOS < @V_DTINICAUX) BEGIN
                SET @V_DTINICAUX = @V_DTINICPOS;
            END;
         END;

         IF (@V_DTINICIAL < @V_DTINICAUX) BEGIN
            SET @V_DTINICIAL = @V_DTINICAUX;
         END;

         DELETE POSESTDIA
         WHERE (CDFILIAL     = @V_CDFILIAL)     AND
               (CDALMOXARIFE = @V_CDALMOXARIFE) AND
               (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
               (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
               (NRSUBLOTE    = @V_NRSUBLOTE)    AND
               (CDPRODUTO    = @V_CDPRODUTO)    AND
               (DTPOSIESTQ  <= @V_DTINICEST);
      END;

      /* DATA FINAL */

      SELECT @V_DTFINAL = MAX(DTLANCMOVI)
      FROM ITLANCTOEST
      WHERE (CDFILIMOVI   = @V_CDFILIAL)     AND
            (CDALMOXARIFE = @V_CDALMOXARIFE) AND
            (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
            (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
            (NRSUBLOTE    = @V_NRSUBLOTE)    AND
            (CDPRODMOVI   = @V_CDPRODUTO);

      IF @V_DTFINAL IS NULL BEGIN
         SET @V_DTFINAL = @P_DTFINAL;
      END
      ELSE BEGIN
         IF (@V_DTFINAL <= @P_DTFINAL) BEGIN
             SET @V_DTFINAL = @P_DTFINAL;
         END;
      END;

      /* LER SALDO INICIAL DO PRODUTO */

      SELECT @V_QTDEESTOPOS   = ROUND(ISNULL(MAX(QTESTOQDIA),0),5),
             @V_VALRESTOPOS   = ROUND(ISNULL(MAX(VRESTOQDIA),0),5),
             @V_VALRBRUTPOS   = ROUND(ISNULL(MAX(VRESTOQBRUT),0),5),
             @V_QTDEANTEPOS   = ROUND(ISNULL(MAX(QTESTOQANT),0),5),
             @V_VRESTANTPOS   = ROUND(ISNULL(MAX(VRESTOQANT),0),5),
             @V_VRBRUANTPOS   = ROUND(ISNULL(MAX(VRBRUTOANT),0),5),
             @V_VALRESTOPOSM1 = ROUND(ISNULL(MAX(VRESTOQDIAM1),0),5) ,
             @V_VALRBRUTPOSM1 = ROUND(ISNULL(MAX(VRESTOQBRUM1),0),5),
             @V_VALRESTOPOSM2 = ROUND(ISNULL(MAX(VRESTOQDIAM2),0),5) ,
             @V_VALRBRUTPOSM2 = ROUND(ISNULL(MAX(VRESTOQBRUM2),0),5),
             @V_VRESTANTPOSM1 = ROUND(ISNULL(MAX(VRESTOQANTM1),0),5) ,
             @V_VRBRUANTPOSM1 = ROUND(ISNULL(MAX(VRBRUTOANTM1),0),5),
             @V_VRESTANTPOSM2 = ROUND(ISNULL(MAX(VRESTOQANTM2),0),5) ,
             @V_VRBRUANTPOSM2 = ROUND(ISNULL(MAX(VRBRUTOANTM2),0),5),
             @V_DTAUXILIAR    = MAX(DTPOSIESTQ),
             @V_DTAUXILIAR    = MAX(DTPOSIESTQ),
             @V_VRCLOGDIAANT  = ROUND(ISNULL(MAX(VRCLOGDIAANT),0),5) ,
             @V_VRSEGUDIAANT  = ROUND(ISNULL(MAX(VRSEGUDIAANT),0),5),
             @V_VRCLOGDIAAM1  = ROUND(ISNULL(MAX(VRCLOGDIAAM1),0),5) ,
             @V_VRCLOGDIAAM2  = ROUND(ISNULL(MAX(VRCLOGDIAAM2),0),5),
             @V_VRSEGUDIAAM1  = ROUND(ISNULL(MAX(VRSEGUDIAAM1),0),5) ,
             @V_VRSEGUDIAAM2  = ROUND(ISNULL(MAX(VRSEGUDIAAM2),0),5),
             @V_VRCUSTOLOGPOS = ROUND(ISNULL(MAX(VRCLOGDIA),0),5) ,
             @V_VRCUSTOSEGPOS = ROUND(ISNULL(MAX(VRSEGUDIA),0),5),
             @V_VRCLOGDIAM1   = ROUND(ISNULL(MAX(VRCLOGDIAM1),0),5) ,
             @V_VRCLOGDIAM2   = ROUND(ISNULL(MAX(VRCLOGDIAM2),0),5),
             @V_VRSEGUDIAM1   = ROUND(ISNULL(MAX(VRSEGUDIAM1),0),5) ,
             @V_VRSEGUDIAM2   = ROUND(ISNULL(MAX(VRSEGUDIAM2),0),5)
      FROM POSESTDIA
      WHERE (CDFILIAL     = @V_CDFILIAL)     AND
            (CDALMOXARIFE = @V_CDALMOXARIFE) AND
            (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
            (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
            (NRSUBLOTE    = @V_NRSUBLOTE)    AND
            (CDPRODUTO    = @V_CDPRODUTO)    AND
            (DTPOSIESTQ   = (SELECT MAX(DTPOSIESTQ)
                             FROM POSESTDIA
                             WHERE (CDFILIAL     = @V_CDFILIAL)     AND
                                   (CDALMOXARIFE = @V_CDALMOXARIFE) AND
                                   (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
                                   (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
                                   (NRSUBLOTE    = @V_NRSUBLOTE)    AND
                                   (CDPRODUTO    = @V_CDPRODUTO)    AND
                                   (DTPOSIESTQ   <= @V_DTINICIAL)));


      DELETE POSESTATU
      WHERE (CDFILIAL     = @V_CDFILIAL)     AND
            (CDALMOXARIFE = @V_CDALMOXARIFE) AND
            (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
            (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
            (NRSUBLOTE    = @V_NRSUBLOTE)    AND
            (CDPRODUTO    = @V_CDPRODUTO);

      DELETE POSESTDIA
      WHERE (CDFILIAL     = @V_CDFILIAL)     AND
            (CDALMOXARIFE = @V_CDALMOXARIFE) AND
            (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
            (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
            (NRSUBLOTE    = @V_NRSUBLOTE)    AND
            (CDPRODUTO    = @V_CDPRODUTO)    AND
            (DTPOSIESTQ   > @V_DTINICIAL);

      /* ATUALIZA SALDO DE ESTOQUE DESDE A DATA INICIAL */
      /* AT A DATA DE PROCESSAMENTO                    */

      SET @V_EXISMOV    = 'N';
      SET @V_DTSALDO    = @V_DTINICIAL;
      SET @V_NRLANCESTQ = 'X';

      SET @V_QTDEESTO   = ISNULL( @V_QTDEESTOPOS,0);
      SET @V_VALRESTO   = ISNULL( @V_VALRESTOPOS,0);
      SET @V_VALRBRUT   = ISNULL( @V_VALRBRUTPOS,0);
      SET @V_QTDEANTE   = ISNULL( @V_QTDEANTEPOS,0);
      SET @V_VRESTANT   = ISNULL( @V_VRESTANTPOS,0);
      SET @V_VRBRUANT   = ISNULL( @V_VRBRUANTPOS,0);
      SET @V_VALRESTOM1 = ISNULL(@V_VALRESTOPOSM1,0);
      SET @V_VALRBRUTM1 = ISNULL(@V_VALRBRUTPOSM1,0);
      SET @V_VALRESTOM2 = ISNULL(@V_VALRESTOPOSM2,0);
      SET @V_VALRBRUTM2 = ISNULL(@V_VALRBRUTPOSM2,0);
      SET @V_VRESTANTM1 = ISNULL(@V_VRESTANTPOSM1,0);
      SET @V_VRBRUANTM1 = ISNULL(@V_VRBRUANTPOSM1,0);
      SET @V_VRESTANTM2 = ISNULL(@V_VRESTANTPOSM2,0);
      SET @V_VRBRUANTM2 = ISNULL(@V_VRBRUANTPOSM2,0);
      SET @V_VRCUSTOLOG = ISNULL(@V_VRCUSTOLOGPOS,0);
      SET @V_VRCUSTOSEG = ISNULL(@V_VRCUSTOSEGPOS,0);


      IF (@V_QTDEESTO <> 0) BEGIN
          SET  @V_QTDEANTE   = @V_QTDEESTOPOS;
          SET  @V_VRESTANT   = @V_VRESTANTPOS;
          SET  @V_VRBRUANT   = @V_VALRBRUTPOS;
          SET  @V_VRESTANTM1 = @V_VRESTANTPOSM1;
          SET  @V_VRBRUANTM1 = @V_VRBRUANTPOSM1;
          SET  @V_VRESTANTM2 = @V_VRESTANTPOSM2;
          SET  @V_VRBRUANTM2 = @V_VRBRUANTPOSM2;
      END;

      SET @V_MOVNEG = 'N';

      IF @V_VRCUSTOLOG <> 0 BEGIN
         SET @V_VRCLOGDIAANT  = @V_VRCUSTOLOG;
      END;

      IF (@V_VRCUSTOSEG <> 0) BEGIN
         SET @V_VRSEGUDIAANT = @V_VRCUSTOSEG;
      END;

      DECLARE C_LANCTOEST CURSOR FOR
      SELECT I.IDTIPOMOVI,   I.DTLANCMOVI,  ISNULL(I.VRLANCTOEST,0),
             ISNULL (I.VRLANCTOBRUT,0), I.QTLANCTOEST, I.IDALTCMEDMV,
             I.CDFILIAL, I.NRLANCESTQ, I.NRSEQUITEM,
             ISNULL(I.VRCUSTLOGLAN,0) VRCUSTLOGLAN,
             ISNULL(I.VRSEGULOGLAN,0) VRSEGULOGLAN,
             L.CDTIPOOPER
      FROM ITLANCTOEST I, LANCTOESTOQ L
      WHERE (I.CDFILIMOVI   = @V_CDFILIAL)     AND
            (I.CDALMOXARIFE = @V_CDALMOXARIFE) AND
            (I.CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
            (I.NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
            (I.NRSUBLOTE    = @V_NRSUBLOTE)    AND
            (I.CDPRODMOVI   = @V_CDPRODUTO)    AND
            (I.DTLANCMOVI   >= @V_DTINICIAL)   AND
            (I.DTLANCMOVI   <= @V_DTFINAL)     AND
            ((I.IDEVOLESTOQ = 'S') OR (I.IDEVOLESTOQ IS NULL)) AND
            (I.CDFILIAL = L.CDFILIAL)  AND
            (I.NRLANCESTQ = L.NRLANCESTQ)
      ORDER BY I.DTLANCMOVI, ISNULL(I.IDORDEMCLC,I.IDTIPOMOVI), I.NRLANCESTQ, I.NRSEQUITEM

      OPEN C_LANCTOEST
      FETCH NEXT FROM C_LANCTOEST INTO @V_IDTIPOMOVI,   @V_DTLANCMOVI,  @V_VRLANCTOEST,
                                       @V_VRLANCTOBRUT, @V_QTLANCTOEST, @V_IDALTCMEDMV,
                                       @V_CDFILILANC,   @V_CURLANCESTQ, @V_NRSEQUITEM,
                                       @V_VRCUSTLOGLAN, @V_VRSEGULOGLAN, @V_CDTIPOOPER;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         IF NOT(@V_CDINDICEMF IS NULL) BEGIN

            SELECT @V_VRINDICE1 = MAX(VRINDICE)
            FROM  INDICE I, MOVINDICE M
            WHERE I.CDTPINDICE  = @V_CDTPINDICE AND
                  I.IDPERVALOR  = @V_IDPERVALOR AND
                  I.CDINDICE    = @V_CDINDICEMF AND
                  I.CDTPINDICE  = M.CDTPINDICE  AND
                  I.IDPERVALOR  = M.IDPERVALOR  AND
                  I.CDINDICE    = M.CDINDICE    AND
                  @V_DTLANCMOVI = M.DTREFIND;

            IF (ISNULL(@V_VRINDICE1,0) = 0) BEGIN
               SET @V_MENSAGEM = ('ndice Financeiro Parametrizado na Personalizao do Sistema,
                                   no Possui valor Cadastrado para a Data'+' '+  CONVERT(VARCHAR,@V_DTLANCMOVI))
               RAISERROR(@V_MENSAGEM, 16,1);
            END;
         END;

         IF NOT(@V_CDINDICEMF2 IS NULL) BEGIN

            SELECT @V_VRINDICE2 = MAX(VRINDICE)
            FROM  INDICE I, MOVINDICE M
            WHERE I.CDTPINDICE  = @V_CDTPINDICE2 AND
                  I.IDPERVALOR  = @V_IDPERVALOR2 AND
                  I.CDINDICE    = @V_CDINDICEMF2 AND
                  I.CDTPINDICE  = M.CDTPINDICE  AND
                  I.IDPERVALOR  = M.IDPERVALOR  AND
                  I.CDINDICE    = M.CDINDICE    AND
                  @V_DTLANCMOVI = M.DTREFIND;

            IF (ISNULL(@V_VRINDICE2,0) = 0) BEGIN
               SET @V_MENSAGEM = ('ndice Financeiro Parametrizado na Personalizao do Sistema,
                                   no Possui valor Cadastrado para a Data'+' '+  CONVERT(VARCHAR,@V_DTLANCMOVI))
               RAISERROR(@V_MENSAGEM,16,1);
            END;

         END;

         IF (@V_DTSALDO > @V_DTLANCMOVI) BEGIN
            SET @V_DTSALDO = (@V_DTLANCMOVI + 1);
         END;

         IF (@V_QTDEESTO  <>  0) BEGIN
            SET @V_QTDEANTE   = @V_QTDEESTO;
            SET @V_VRESTANT   = @V_VALRESTO;
            SET @V_VRBRUANT   = @V_VALRBRUT;

            SET @V_VRESTANTM1 = @V_VALRESTOPOSM1;
            SET @V_VRBRUANTM1 = @V_VALRBRUTPOSM1;
            SET @V_VRESTANTM2 = @V_VALRESTOPOSM2;
            SET @V_VRBRUANTM2 = @V_VALRBRUTPOSM2;

            SET @V_VRCLOGDIAANT = @V_VRCUSTOLOG;
            SET @V_VRSEGUDIAANT = @V_VRCUSTOSEG;

         END;

         IF ((@V_DTLANCMOVI + 1) = @V_DTAUXILIAR) BEGIN
            SET @V_QTDEESTO   = 0;
            SET @V_VALRESTO   = 0;
            SET @V_VALRBRUT   = 0;
            SET @V_QTDEANTE   = 0;
            SET @V_VRESTANT   = 0;
            SET @V_VRBRUANT   = 0;

            SET @V_VRESTANTM1 = 0;
            SET @V_VRBRUANTM1 = 0;
            SET @V_VRESTANTM2 = 0;
            SET @V_VRBRUANTM2 = 0;

            SET @V_VRCUSTOLOG   = 0;
            SET @V_VRCUSTOSEG   = 0;
            SET @V_VRCLOGDIAANT = 0;
            SET @V_VRSEGUDIAANT = 0;

         END;

         SET @V_EXISMOV = 'S';

         /* TRATAMENTO PARA CADA REGISTRO DE LANAMENTO DE ESTOQUE */

         IF (@V_IDTIPOMOVI = '0') BEGIN /* IMPLANTAO */
            IF (@V_NRLANCESTQ <> (@V_CDFILILANC + @V_CURLANCESTQ)) BEGIN
               SET @V_VALRBRUT = @V_VRLANCTOBRUT;
               SET @V_VALRESTO = @V_VRLANCTOEST;
               SET @V_QTDEESTO = @V_QTLANCTOEST;
            END
            ELSE BEGIN
               SET @V_VALRBRUT = @V_VALRBRUT + @V_VRLANCTOBRUT;
               SET @V_VALRESTO = @V_VALRESTO + @V_VRLANCTOEST;
               SET @V_QTDEESTO = @V_QTDEESTO + @V_QTLANCTOEST;
            END
            SET @V_VRCUSTOLOG  = 0;                /*AQUI*/
            SET @V_VRCUSTOSEG  = 0;

         END
         ELSE IF (@V_IDTIPOMOVI = '1') BEGIN /* AJUSTES */

            IF ISNULL(@V_IDALTCMEDMV,'N') <> 'S' BEGIN
               IF @V_QTDEESTO = 0 BEGIN
                  IF @V_QTDEANTE <> 0 BEGIN
                     IF (@V_QTLANCTOEST <> 0) BEGIN
                        SET @V_VALRBRUT = (@V_VRBRUANT/@V_QTDEANTE)*@V_QTLANCTOEST;
                        SET @V_VALRESTO = (@V_VRESTANT/@V_QTDEANTE)*@V_QTLANCTOEST;

                        IF @V_QTDEANTE > @V_QTLANCTOEST BEGIN
                           SET @V_VRCUSTOLOG = @V_VRCUSTOLOG - ((@V_VRCUSTOLOG/@V_QTDEANTE) * ABS(@V_QTLANCTOEST-@V_QTDEANTE));
                           SET @V_VRCUSTOSEG = @V_VRCUSTOSEG - ((@V_VRCUSTOSEG/@V_QTDEANTE) * ABS(@V_QTLANCTOEST-@V_QTDEANTE));
                        END
                        ELSE BEGIN
                           IF @V_QTDEANTE > @V_QTLANCTOEST BEGIN
                              SET @V_VRCUSTOLOG = @V_VRCUSTOLOG + ((@V_VRCUSTOLOG/@V_QTDEANTE) * ABS(@V_QTLANCTOEST-@V_QTDEANTE));
                              SET @V_VRCUSTOSEG = @V_VRCUSTOSEG + ((@V_VRCUSTOSEG/@V_QTDEANTE) * ABS(@V_QTLANCTOEST-@V_QTDEANTE));
                           END;
                        END;

                        SET @V_VRBRUANT = 0;
                        SET @V_VRESTANT = 0;
                        SET @V_QTDEANTE = 0;
                        SET @V_VRESTANTM1 = 0;
                        SET @V_VRBRUANTM1 = 0;
                        SET @V_VRESTANTM2 = 0;
                        SET @V_VRBRUANTM2 = 0;

                        SET @V_VRCLOGDIAANT = 0;
                        SET @V_VRSEGUDIAANT = 0;

                     END
                     ELSE BEGIN
                        SET @V_VALRBRUT = 0;
                        SET @V_VALRESTO = 0;
                        SET @V_VRESTANTM1 = 0;
                        SET @V_VRBRUANTM1 = 0;
                        SET @V_VRESTANTM2 = 0;
                        SET @V_VRBRUANTM2 = 0;

                        SET @V_VRCLOGDIAANT = 0;
                        SET @V_VRSEGUDIAANT = 0;
                     END;
                  END
                  ELSE BEGIN
                     SET @V_VALRBRUT = 0;
                     SET @V_VALRESTO = 0;
                     SET @V_VRBRUANT = 0;
                     SET @V_VRESTANT = 0;
                     SET @V_QTDEANTE = 0;
                  END;
               END
               ELSE BEGIN
                  SET @V_VALRBRUT = (@V_VALRBRUT/@V_QTDEESTO)*@V_QTLANCTOEST;
                  SET @V_VALRESTO = (@V_VALRESTO/@V_QTDEESTO)*@V_QTLANCTOEST;

                  IF @V_QTDEESTO > @V_QTLANCTOEST BEGIN
                     SET @V_VRCUSTOLOG = @V_VRCUSTOLOG - ((@V_VRCUSTOLOG/@V_QTDEESTO) * ABS(@V_QTLANCTOEST-@V_QTDEESTO));
                     SET @V_VRCUSTOSEG = @V_VRCUSTOSEG - ((@V_VRCUSTOSEG/@V_QTDEESTO) * ABS(@V_QTLANCTOEST-@V_QTDEESTO));
                  END
                  ELSE BEGIN
                     IF @V_QTDEESTO < @V_QTLANCTOEST BEGIN
                        SET @V_VRCUSTOLOG = @V_VRCUSTOLOG + ((@V_VRCUSTOLOG/@V_QTDEESTO) * ABS(@V_QTLANCTOEST-@V_QTDEESTO));
                        SET @V_VRCUSTOSEG = @V_VRCUSTOSEG + ((@V_VRCUSTOSEG/@V_QTDEESTO) * ABS(@V_QTLANCTOEST-@V_QTDEESTO));
                     END;
                  END;
               END;
            END;
            SET @V_QTDEESTO = @V_QTLANCTOEST;
         END
         ELSE IF (@V_IDTIPOMOVI = '2') BEGIN /* ENTRADA */
            IF (@V_QTLANCTOEST <> 0 OR @V_CDTIPOOPER = '03' ) BEGIN
               SET @V_QTDEESTO = @V_QTDEESTO + @V_QTLANCTOEST;

               SET @V_VRCUSTOLOG   = @V_VRCUSTOLOG +  @V_VRCUSTLOGLAN;
               SET @V_VRCUSTOSEG   = @V_VRCUSTOSEG +  @V_VRSEGULOGLAN;

               IF @V_QTLANCTOEST = 0 BEGIN
                  SET @V_VALRBRUT = @V_VALRBRUT + @V_VRLANCTOBRUT;
                  SET @V_VALRESTO = @V_VALRESTO + @V_VRLANCTOEST;
               END
               ELSE BEGIN
                  SET @V_VALRBRUT = @V_VALRBRUT + (@V_QTLANCTOEST*@V_VRLANCTOBRUT);
                  SET @V_VALRESTO = @V_VALRESTO + (@V_QTLANCTOEST*@V_VRLANCTOEST);
               END;

               IF @V_QTDEESTO  = 0 BEGIN
                  SET @V_VALRBRUT = 0;
                  SET @V_VALRESTO = 0;
               END;
            END;
         END
         ELSE IF (@V_IDTIPOMOVI = '3') BEGIN /* RETIRADA */
            IF @V_QTDEESTO > 0 BEGIN
               SET @V_VALRBRUT = @V_VALRBRUT - ((@V_VALRBRUT/@V_QTDEESTO)*@V_QTLANCTOEST);
               SET @V_VALRESTO = @V_VALRESTO - ((@V_VALRESTO/@V_QTDEESTO)*@V_QTLANCTOEST);

               SET @V_VRCUSTOLOG = @V_VRCUSTOLOG - ((@V_VRCUSTOLOG/@V_QTDEESTO) * @V_QTLANCTOEST);
               SET @V_VRCUSTOSEG = @V_VRCUSTOSEG - ((@V_VRCUSTOSEG/@V_QTDEESTO) * @V_QTLANCTOEST);
            END;

            SET @V_QTDEESTO = @V_QTDEESTO - @V_QTLANCTOEST;

            IF (@V_QTDEESTO < 0) BEGIN
               IF (@V_QTDEANTE <> 0) BEGIN
                  SET @V_VALRESTO = ((@V_VRESTANT/@V_QTDEANTE)*@V_QTDEESTO);
                  SET @V_VALRBRUT = ((@V_VRBRUANT/@V_QTDEANTE)*@V_QTDEESTO);
               END
               ELSE BEGIN
                  SET @V_VALRESTO = 0;
                  SET @V_VALRBRUT = 0;
               END;
            END;

            IF ROUND(@V_QTDEESTO,3) = 0 BEGIN
               SET @V_QTDEESTO = 0;
            END;

            IF @V_QTDEESTO  = 0 BEGIN
               SET @V_VALRBRUT   = 0;
               SET @V_VALRESTO   = 0;
            END;
            IF (@V_QTDEESTO < -0.0000001) BEGIN
               SET @V_MOVNEG = 'S';
            END;
         END
         ELSE IF (@V_IDTIPOMOVI = '4') BEGIN /* SADA */
            IF (@V_QTLANCTOEST <> 0 OR @V_CDTIPOOPER = '03' ) BEGIN
               IF (@V_QTDEESTO > 0) BEGIN

                  SET @V_VALRBRUT = @V_VALRBRUT - ((@V_VALRBRUT/@V_QTDEESTO)* @V_QTLANCTOEST);
                  SET @V_VALRESTO = @V_VALRESTO - ((@V_VALRESTO/@V_QTDEESTO)* @V_QTLANCTOEST);

                  SET @V_VRCUSTOLOG = @V_VRCUSTOLOG - ((@V_VRCUSTOLOG/@V_QTDEESTO) * @V_QTLANCTOEST);
                  SET @V_VRCUSTOSEG = @V_VRCUSTOSEG - ((@V_VRCUSTOSEG/@V_QTDEESTO) * @V_QTLANCTOEST);
               END;

               SET @V_QTDEESTO = @V_QTDEESTO - @V_QTLANCTOEST;

               IF (@V_QTDEESTO < 0) BEGIN
                  IF (@V_QTDEANTE <> 0) BEGIN
                     SET @V_VALRESTO = ((@V_VRESTANT/@V_QTDEANTE)*@V_QTDEESTO);
                     SET @V_VALRBRUT = ((@V_VRBRUANT/@V_QTDEANTE)*@V_QTDEESTO);
                  END
                  ELSE BEGIN
                     SET @V_VALRESTO = 0;
                     SET @V_VALRBRUT = 0;
                  END;
               END;

               IF ROUND(@V_QTDEESTO,3) = 0 BEGIN
                  SET @V_QTDEESTO = 0;
               END;

               IF @V_QTDEESTO  = 0 BEGIN
                  SET @V_VALRBRUT   = 0;
                  SET @V_VALRESTO   = 0;
               END;
               IF (@V_QTDEESTO <  -0.0000001) BEGIN
                  SET @V_MOVNEG = 'S';
               END;
            END;
         END
         ELSE IF (@V_IDTIPOMOVI = '5') BEGIN /* DEV. FORN. */

            IF @V_QTLANCTOEST = 0 BEGIN
               SET @V_VALRBRUT = @V_VALRBRUT - @V_VRLANCTOBRUT;
               SET @V_VALRESTO = @V_VALRESTO - @V_VRLANCTOEST;
            END
            ELSE BEGIN
               SET @V_CUSTPROD = 0;

               IF @V_QTDEESTO <> 0 BEGIN
                  SET @V_CUSTPROD = @V_VALRBRUT / @V_QTDEESTO;
               END
               ELSE BEGIN
                  IF @V_QTDEANTE <> 0 BEGIN
                     SET @V_CUSTPROD = @V_VRBRUANT / @V_QTDEANTE;
                  END;
               END;

               IF (@V_VALRBRUT - (@V_QTLANCTOEST*@V_VRLANCTOBRUT)) >= 0 BEGIN
                  SET @V_VALRBRUT = @V_VALRBRUT - (@V_QTLANCTOEST*@V_VRLANCTOBRUT);
               END
               ELSE BEGIN
                  SET @V_VALRBRUT = @V_VALRBRUT - (@V_QTLANCTOEST*@V_CUSTPROD);
               END;

               SET @V_CUSTPROD = 0;
               IF @V_QTDEESTO <> 0 BEGIN
                  SET @V_CUSTPROD = @V_VALRESTO / @V_QTDEESTO;
               END
               ELSE BEGIN
                  IF @V_QTDEANTE <> 0 BEGIN
                     SET @V_CUSTPROD = @V_VRESTANT / @V_QTDEANTE;
                  END;
               END;

               IF (@V_VALRESTO - (@V_QTLANCTOEST*@V_VRLANCTOEST)) >= 0 BEGIN
                  SET @V_VALRESTO = @V_VALRESTO - (@V_QTLANCTOEST*@V_VRLANCTOEST);
               END
               ELSE BEGIN
                  SET @V_VALRESTO = @V_VALRESTO - (@V_QTLANCTOEST*@V_CUSTPROD);
               END;
               IF (@V_QTDEESTO <  -0.0000001) BEGIN
                  SET @V_MOVNEG = 'S';
               END;
            END;

            SET @V_QTDEESTO = @V_QTDEESTO - @V_QTLANCTOEST;

            IF ROUND(@V_QTDEESTO,3) = 0 BEGIN
               SET @V_QTDEESTO = 0;
            END;

            IF @V_QTDEESTO  = 0 BEGIN
               SET @V_VALRBRUT = 0;
               SET @V_VALRESTO = 0;
            END;
         END;

         /* GRAVAO DOS SALDOS DIRIOS PARA O PRODUTO */
         WHILE (@V_DTSALDO <= (@V_DTLANCMOVI + 1)) BEGIN
            IF (@V_CDINDICEMF IS NOT NULL) BEGIN
               SET @V_VALRBRUTM1  = @V_VALRBRUT / @V_VRINDICE1;
               SET @V_VALRESTOM1  = @V_VALRESTO / @V_VRINDICE1;

               SET @V_VRCLOGDIAM1 = @V_VRCUSTOLOG / @V_VRINDICE1;
               SET @V_VRSEGUDIAM1 = @V_VRCUSTOSEG / @V_VRINDICE1;
            END;

            IF (@V_CDINDICEMF2 IS NOT NULL) BEGIN
               SET @V_VALRBRUTM2 = @V_VALRBRUT / @V_VRINDICE2;
               SET @V_VALRESTOM2 = @V_VALRESTO / @V_VRINDICE2;

               SET @V_VRCLOGDIAM2 = @V_VRCUSTOLOG / @V_VRINDICE2;
               SET @V_VRSEGUDIAM2 = @V_VRCUSTOSEG / @V_VRINDICE2;
            END;

            SELECT @V_COUNTPOS = COUNT(*)
            FROM POSESTDIA
            WHERE (CDFILIAL     = @V_CDFILIAL)     AND
                  (CDALMOXARIFE = @V_CDALMOXARIFE) AND
                  (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
                  (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
                  (NRSUBLOTE    = @V_NRSUBLOTE)    AND
                  (CDPRODUTO    = @V_CDPRODUTO)    AND
                  (DTPOSIESTQ   = @V_DTSALDO);

            IF (@V_COUNTPOS = 0) BEGIN
               IF @V_QTDEESTO = 0 BEGIN
                  SET @V_POSIZERO = 'S';
               END
               ELSE BEGIN
                  SET @V_POSIZERO = 'N';
               END;

               IF (@V_DTSALDO > @V_DTLANCMOVI) BEGIN
                  INSERT INTO POSESTDIA (CDFILIAL,   CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,
                                         NRSUBLOTE,  CDPRODUTO,    DTPOSIESTQ,   QTESTOQDIA,
                                         VRESTOQDIA, VRESTOQBRUT,  IDPOSIZERO,   QTESTOQANT,
                                         VRESTOQANT,   VRBRUTOANT, VRESTOQDIAM1, VRESTOQBRUM1,
                                         VRESTOQANTM1, VRBRUTOANTM1, VRESTOQDIAM2, VRESTOQBRUM2,
                                         VRESTOQANTM2, VRBRUTOANTM2, VRCLOGDIAANT, VRSEGUDIAANT,
                                         VRCLOGDIA,    VRSEGUDIA,    VRCLOGDIAAM1, VRCLOGDIAAM2,
                                         VRSEGUDIAAM1, VRSEGUDIAAM2, VRCLOGDIAM1,  VRCLOGDIAM2,
                                         VRSEGUDIAM1,  VRSEGUDIAM2)
                                 VALUES (@V_CDFILIAL,   @V_CDALMOXARIFE, @V_CDLOCALESTOQ, @V_NRLOTEESTQ,
                                         @V_NRSUBLOTE,  @V_CDPRODUTO,    @V_DTSALDO,
                                         @V_QTDEESTO,   @V_VALRESTO,     @V_VALRBRUT ,    @V_POSIZERO,
                                         @V_QTDEANTE,   @V_VRESTANT,     @V_VRBRUANT,
                                         @V_VALRESTOM1, @V_VALRBRUTM1,   @V_VRESTANTM1, @V_VRBRUANTM1,
                                         @V_VALRESTOM2, @V_VALRBRUTM2,   @V_VRESTANTM2, @V_VRBRUANTM2,
                                         @V_VRCLOGDIAANT, @V_VRSEGUDIAANT,  @V_VRCUSTOLOG,   @V_VRCUSTOSEG,
                                         @V_VRCLOGDIAAM1,  @V_VRCLOGDIAAM2, @V_VRSEGUDIAAM1, @V_VRSEGUDIAAM2,
                                         @V_VRCLOGDIAM1,   @V_VRCLOGDIAM2,  @V_VRSEGUDIAM1,  @V_VRSEGUDIAM2 );
               END;
            END
            ELSE BEGIN
               IF (@V_DTSALDO < (@V_DTLANCMOVI + 1)) BEGIN
                  IF @V_QTDEESTOPOS = 0 BEGIN
                     SET @V_POSIZERO = 'S';
                  END
                  ELSE BEGIN
                     SET @V_POSIZERO = 'N';
                  END;

                  UPDATE POSESTDIA
                  SET QTESTOQDIA    = @V_QTDEESTOPOS,
                      VRESTOQDIA    = @V_VALRESTOPOS,
                      VRESTOQBRUT   = @V_VALRBRUTPOS,
                      IDPOSIZERO    = @V_POSIZERO,
                      QTESTOQANT    = @V_QTDEANTEPOS,
                      VRESTOQANT    = @V_VRESTANTPOS,
                      VRBRUTOANT    = @V_VRBRUANTPOS,
                      VRESTOQDIAM1  = @V_VALRESTOPOSM1,
                      VRESTOQBRUM1  = @V_VALRBRUTPOSM1,
                      VRESTOQDIAM2  = @V_VALRESTOPOSM2,
                      VRESTOQBRUM2  = @V_VALRBRUTPOSM2,
                      VRESTOQANTM1  = @V_VRESTANTPOSM1,
                      VRBRUTOANTM1  = @V_VRBRUANTPOSM1,
                      VRESTOQANTM2  = @V_VRESTANTPOSM2,
                      VRBRUTOANTM2  = @V_VRBRUANTPOSM2,
                      VRCLOGDIAANT  = @V_VRCLOGDIAANT,
                      VRSEGUDIAANT  = @V_VRSEGUDIAANT,
                      VRCLOGDIA     = @V_VRCUSTOLOGPOS,
                      VRSEGUDIA     = @V_VRCUSTOSEGPOS,
                      VRCLOGDIAAM1  = @V_VRCLOGDIAAM1,
                      VRCLOGDIAAM2  = @V_VRCLOGDIAAM2,
                      VRSEGUDIAAM1  = @V_VRSEGUDIAAM1,
                      VRSEGUDIAAM2  = @V_VRSEGUDIAAM2,
                      VRCLOGDIAM1   = @V_VRCLOGDIAM1,
                      VRCLOGDIAM2   = @V_VRCLOGDIAM2,
                      VRSEGUDIAM1   = @V_VRSEGUDIAM1,
                      VRSEGUDIAM2   = @V_VRSEGUDIAM2
                  WHERE (CDFILIAL     = @V_CDFILIAL)     AND
                        (CDALMOXARIFE = @V_CDALMOXARIFE) AND
                        (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
                        (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
                        (NRSUBLOTE    = @V_NRSUBLOTE)    AND
                        (CDPRODUTO    = @V_CDPRODUTO)    AND
                        (DTPOSIESTQ   = @V_DTSALDO);
               END
               ELSE BEGIN
                  IF @V_QTDEESTO = 0 BEGIN
                     SET @V_POSIZERO = 'S';
                  END
                  ELSE BEGIN
                     SET @V_POSIZERO = 'N';
                  END;

                  UPDATE POSESTDIA
                  SET QTESTOQDIA    = @V_QTDEESTO,
                      VRESTOQDIA    = @V_VALRESTO,
                      VRESTOQBRUT   = @V_VALRBRUT,
                      IDPOSIZERO    = @V_POSIZERO,
                      QTESTOQANT    = @V_QTDEANTE,
                      VRESTOQANT    = @V_VRESTANT,
                      VRBRUTOANT    = @V_VRBRUANT,
                      VRESTOQDIAM1  = @V_VALRESTOM1,
                      VRESTOQBRUM1  = @V_VALRBRUTM1,
                      VRESTOQDIAM2  = @V_VALRESTOM2,
                      VRESTOQBRUM2  = @V_VALRBRUTM2,
                      VRESTOQANTM1  = @V_VRESTANTM1,
                      VRBRUTOANTM1  = @V_VRBRUANTM1,
                      VRESTOQANTM2  = @V_VRESTANTM2,
                      VRBRUTOANTM2  = @V_VRBRUANTM2,
                      VRCLOGDIAANT  = @V_VRCLOGDIAANT,
                      VRSEGUDIAANT  = @V_VRSEGUDIAANT,
                      VRCLOGDIA     = @V_VRCUSTOLOG,
                      VRSEGUDIA     = @V_VRCUSTOSEG,
                      VRCLOGDIAAM1  = @V_VRCLOGDIAAM1,
                      VRCLOGDIAAM2  = @V_VRCLOGDIAAM2,
                      VRSEGUDIAAM1  = @V_VRSEGUDIAAM1,
                      VRSEGUDIAAM2  = @V_VRSEGUDIAAM2,
                      VRCLOGDIAM1   = @V_VRCLOGDIAM1,
                      VRCLOGDIAM2   = @V_VRCLOGDIAM2,
                      VRSEGUDIAM1   = @V_VRSEGUDIAM1,
                      VRSEGUDIAM2   = @V_VRSEGUDIAM2
                  WHERE (CDFILIAL     = @V_CDFILIAL)     AND
                        (CDALMOXARIFE = @V_CDALMOXARIFE) AND
                        (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
                        (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
                        (NRSUBLOTE    = @V_NRSUBLOTE)    AND
                        (CDPRODUTO    = @V_CDPRODUTO)    AND
                        (DTPOSIESTQ   = @V_DTSALDO);
               END;
            END;
            SET @V_DTSALDO  = @V_DTSALDO + 1;
         END;
         /* GUARDA OS VALORES DE ESTOQUE ANTERIORES  PRXIMA MOVIMENTAO */

         SET @V_QTDEESTOPOS   = ISNULL( @V_QTDEESTO ,0);
         SET @V_VALRESTOPOS   = ISNULL( @V_VALRESTO ,0);
         SET @V_VALRBRUTPOS   = ISNULL( @V_VALRBRUT ,0);
         SET @V_VALRESTOPOSM1 = ISNULL( @V_VALRESTOM1 ,0);
         SET @V_VALRBRUTPOSM1 = ISNULL( @V_VALRBRUTM1 ,0);
         SET @V_VALRESTOPOSM2 = ISNULL( @V_VALRESTOM2 ,0);
         SET @V_VALRBRUTPOSM2 = ISNULL( @V_VALRBRUTM2 ,0);
         SET @V_QTDEANTEPOS   = ISNULL( @V_QTDEANTE ,0);
         SET @V_VRESTANTPOS   = ISNULL( @V_VRESTANT ,0);
         SET @V_VRBRUANTPOS   = ISNULL( @V_VRBRUANT ,0);
         SET @V_VRESTANTPOSM1 = ISNULL( @V_VRESTANTM1 ,0);
         SET @V_VRBRUANTPOSM1 = ISNULL( @V_VRBRUANTM1 ,0);
         SET @V_VRESTANTPOSM2 = ISNULL( @V_VRESTANTM2 ,0);
         SET @V_VRBRUANTPOSM2 = ISNULL( @V_VRBRUANTM2 ,0);
         SET @V_VRCUSTOLOGPOS = ISNULL( @V_VRCUSTOLOG ,0);
         SET @V_VRCUSTOSEGPOS = ISNULL( @V_VRCUSTOSEG ,0);


         SET @V_NRLANCESTQ = (@V_CDFILILANC + @V_CURLANCESTQ);

         FETCH NEXT FROM C_LANCTOEST INTO @V_IDTIPOMOVI,   @V_DTLANCMOVI,  @V_VRLANCTOEST,
                                          @V_VRLANCTOBRUT, @V_QTLANCTOEST, @V_IDALTCMEDMV,
                                          @V_CDFILILANC,   @V_CURLANCESTQ, @V_NRSEQUITEM,
                                          @V_VRCUSTLOGLAN, @V_VRSEGULOGLAN,@V_CDTIPOOPER;
      END;
      CLOSE C_LANCTOEST;
      DEALLOCATE C_LANCTOEST;

      UPDATE PRODLCESTOQ
      SET DTRECALCEST  = @V_DTSALDO-1
      WHERE (CDFILIAL     = @V_CDFILIAL)     AND
            (CDALMOXARIFE = @V_CDALMOXARIFE) AND
            (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
            (CDPRODUTO    = @V_CDPRODUTO);


      SELECT @V_IDESTONEG = MAX(CDFILIAL)
      FROM POSESTDIA
      WHERE (CDFILIAL     = @V_CDFILIAL)     AND
            (CDALMOXARIFE = @V_CDALMOXARIFE) AND
            (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
            (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
            (NRSUBLOTE    = @V_NRSUBLOTE)    AND
            (CDPRODUTO    = @V_CDPRODUTO)    AND
            (DTPOSIESTQ   > @P_DTINICIAL)    AND
            (QTESTOQDIA   <  -0.0000001);

      UPDATE POSESTDIA
      SET VRESTOQDIA    = 0,
          VRESTOQBRUT   = 0,
          VRESTOQDIAM1  = 0,
          VRESTOQBRUM1  = 0,
          VRESTOQDIAM2  = 0,
          VRESTOQBRUM2  = 0,
          VRCLOGDIAM1   = 0,
          VRCLOGDIAM2   = 0,
          VRSEGUDIAM1   = 0,
          VRSEGUDIAM2   = 0
      WHERE (CDFILIAL     = @V_CDFILIAL)     AND
            (CDALMOXARIFE = @V_CDALMOXARIFE) AND
            (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
            (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
            (NRSUBLOTE    = @V_NRSUBLOTE)    AND
            (CDPRODUTO    = @V_CDPRODUTO)    AND
            (QTESTOQDIA   = 0)               AND
            (DTPOSIESTQ  >= @P_DTINICIAL);

      UPDATE POSESTDIA
      SET VRESTOQANT    = 0,
          VRESTOQANTM1  = 0,
          VRESTOQANTM2  = 0,
          VRBRUTOANT    = 0,
          VRBRUTOANTM1  = 0,
          VRBRUTOANTM2  = 0,
          VRCLOGDIAAM1  = 0,
          VRCLOGDIAAM2  = 0,
          VRSEGUDIAAM1  = 0,
          VRSEGUDIAAM2  = 0
      WHERE (CDFILIAL     = @V_CDFILIAL)     AND
            (CDALMOXARIFE = @V_CDALMOXARIFE) AND
            (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
            (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
            (NRSUBLOTE    = @V_NRSUBLOTE)    AND
            (CDPRODUTO    = @V_CDPRODUTO)    AND
            (QTESTOQANT   = 0)               AND
            (DTPOSIESTQ  >= @P_DTINICIAL);

      SELECT @V_QTDEESTO    = ROUND(ISNULL(MAX(QTESTOQDIA),0),5),
             @V_VALRESTO    = ROUND(ISNULL(MAX(VRESTOQDIA),0),5),
             @V_VALRBRUT    = ROUND(ISNULL(MAX(VRESTOQBRUT),0),5),
             @V_VALRESTOM1  = ROUND(ISNULL(MAX(VRESTOQDIAM1),0),5),
             @V_VALRESTOM2  = ROUND(ISNULL(MAX(VRESTOQDIAM2),0),5),
             @V_DTPOSIESTQ  = MAX(DTPOSIESTQ),
             @V_VRCUSTOLOG  = ROUND(ISNULL(MAX(VRCLOGDIA),0),5),
             @V_VRCLOGDIAM1 = ROUND(ISNULL(MAX(VRCLOGDIAM1),0),5),
             @V_VRCLOGDIAM2 = ROUND(ISNULL(MAX(VRCLOGDIAM2),0),5),
             @V_VRCUSTOSEG  = ROUND(ISNULL(MAX(VRSEGUDIA),0),5),
             @V_VRSEGUDIAM1 = ROUND(ISNULL(MAX(VRSEGUDIAM1),0),5),
             @V_VRSEGUDIAM2 = ROUND(ISNULL(MAX(VRSEGUDIAM2),0),5)
      FROM POSESTDIA
      WHERE (CDFILIAL     = @V_CDFILIAL)     AND
            (CDALMOXARIFE = @V_CDALMOXARIFE) AND
            (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
            (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
            (NRSUBLOTE    = @V_NRSUBLOTE)    AND
            (CDPRODUTO    = @V_CDPRODUTO)    AND
            (DTPOSIESTQ   = (SELECT MAX(DTPOSIESTQ)
                             FROM POSESTDIA
                             WHERE (CDFILIAL     = @V_CDFILIAL)     AND
                                   (CDALMOXARIFE = @V_CDALMOXARIFE) AND
                                   (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
                                   (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
                                   (NRSUBLOTE    = @V_NRSUBLOTE)    AND
                                   (CDPRODUTO    = @V_CDPRODUTO)));

      IF (@V_IDESTONEG IS NULL) BEGIN
         IF (@V_MOVNEG <> 'S') BEGIN
            SELECT @V_QTRESPRODPED = ISNULL(SUM(QTRESPRODPED),0)
            FROM RESERPRODPED
            WHERE CDFILIAL     = @V_CDFILIAL     AND
                  CDALMOXARIFE = @V_CDALMOXARIFE AND
                  CDLOCALESTOQ = @V_CDLOCALESTOQ AND
                  NRLOTEESTQ   = @V_NRLOTEESTQ   AND
                  NRSUBLOTE    = @V_NRSUBLOTE    AND
                  CDPRODUTO    = @V_CDPRODUTO;


             SELECT @V_IDNFDEVOOL = ISNULL(MAX(IDNFDEVOOL), 'N')
               FROM NOTAFISCAL N, LANCTOESTOQ L
              WHERE N.CDFILIAL = L.CDFILIAL
                AND N.NRLANCTONF = L.NRLANCTONF
                AND L.CDFILIAL = @P_FILILANCTO
                AND L.NRLANCESTQ = @P_NRLANCTO;

             IF (@V_IDNFDEVOOL = 'N') BEGIN
                 SELECT @V_QTRESPRODPEDOL = ISNULL(SUM(RE.QTRESERVESTOL), 0)
                  FROM RESERVAPEDEXOL RE, RELACPRODOL R
                 WHERE R.CDPRODARVOL = @V_CDPRODUTO
                   AND RE.CDPRODUTO  =  R.CDPRARVORIG
                   AND RE.CDFILRESOL =  @V_CDFILIAL
                   AND RE.CDMARCA    =  R.CDMARCA;
             END
             ELSE BEGIN
                SELECT @V_QTRESPRODPEDOL = ISNULL(SUM(RE.QTRESERVESTOL), 0)
                  FROM RESERVAPEDEXOL RE, RELACPRODOL R
                 WHERE R.CDPRARVORIG = @V_CDPRODUTO
                   AND RE.CDPRODUTO  =  R.CDPRARVORIG
                   AND RE.CDFILRESOL =  @V_CDFILIAL
                   AND RE.CDMARCA    =  R.CDMARCA;
             END;

            SET @V_QTRESPRODPED = ISNULL(@V_QTRESPRODPED,0) + ISNULL(@V_QTRESPRODPEDOL,0);

            SET @V_QTRESPRODPED = ISNULL(@V_QTDEESTO,0) - ISNULL(@V_QTRESPRODPED,0);
            IF (@V_QTRESPRODPED >=  -0.00001) BEGIN
               IF (ISNULL(@V_QTDEESTO,0) = 0) BEGIN
                  UPDATE LOTE
                  SET IDSTATLOTE = 'E'
                  WHERE CDFILIAL   = @V_CDFILIAL   AND
                        CDPRODUTO  = @V_CDPRODUTO  AND
                        NRLOTEESTQ = @V_NRLOTEESTQ AND
                        NRSUBLOTE  = @V_NRSUBLOTE;

                  DELETE MOVILOTE
                  WHERE NRMOVILOTE   = @P_FILILANCTO + @P_NRLANCTO AND
                        CDFILIAL     = @V_CDFILIAL         AND
                        CDALMOXARIFE = @V_CDALMOXARIFE     AND
                        CDLOCALESTOQ = @V_CDLOCALESTOQ     AND
                        NRLOTEESTQ   = @V_NRLOTEESTQ       AND
                        NRSUBLOTE    = @V_NRSUBLOTE        AND
                        CDPRODUTO    = @V_CDPRODUTO;

                  DELETE MOVILOTE
                  WHERE NRLANCTOORIG = @P_FILILANCTO + @P_NRLANCTO AND
                        CDFILIAL     = @V_CDFILIAL         AND
                        CDALMOXARIFE = @V_CDALMOXARIFE     AND
                        CDLOCALESTOQ = @V_CDLOCALESTOQ     AND
                        NRLOTEESTQ   = @V_NRLOTEESTQ       AND
                        NRSUBLOTE    = @V_NRSUBLOTE        AND
                        CDPRODUTO    = @V_CDPRODUTO;

               END
               ELSE IF (ISNULL(@V_QTDEESTO,0) > 0) BEGIN
                  UPDATE LOTE
                  SET IDSTATLOTE = 'L'
                  WHERE CDFILIAL   = @V_CDFILIAL   AND
                        CDPRODUTO  = @V_CDPRODUTO  AND
                        NRLOTEESTQ = @V_NRLOTEESTQ AND
                        NRSUBLOTE  = @V_NRSUBLOTE;

                  DELETE FROM MOVILOTE
                  WHERE NRMOVILOTE   = @P_FILILANCTO + @P_NRLANCTO AND
                        CDFILIAL     = @V_CDFILIAL                 AND
                        CDALMOXARIFE = @V_CDALMOXARIFE             AND
                        CDLOCALESTOQ = @V_CDLOCALESTOQ             AND
                        NRLOTEESTQ   = @V_NRLOTEESTQ               AND
                        NRSUBLOTE    = @V_NRSUBLOTE                AND
                        CDPRODUTO    = @V_CDPRODUTO;

                  DELETE FROM MOVILOTE
                  WHERE NRLANCTOORIG = @P_FILILANCTO + @P_NRLANCTO AND
                        CDFILIAL     = @V_CDFILIAL                 AND
                        CDALMOXARIFE = @V_CDALMOXARIFE             AND
                        CDLOCALESTOQ = @V_CDLOCALESTOQ             AND
                        NRLOTEESTQ   = @V_NRLOTEESTQ               AND
                        NRSUBLOTE    = @V_NRSUBLOTE                AND
                        CDPRODUTO    = @V_CDPRODUTO;
               END;
            END;
         END;
      END;

      IF (@V_QTDEESTO <> 0) BEGIN
          SELECT @V_COUNTPOS = COUNT(*)
          FROM POSESTATU
          WHERE CDFILIAL     = @V_CDFILIAL     AND
                CDALMOXARIFE = @V_CDALMOXARIFE AND
                CDLOCALESTOQ = @V_CDLOCALESTOQ AND
                NRLOTEESTQ   = @V_NRLOTEESTQ   AND
                NRSUBLOTE    = @V_NRSUBLOTE    AND
                CDPRODUTO    = @V_CDPRODUTO;

          IF (@V_COUNTPOS = 0) BEGIN
             INSERT INTO POSESTATU
                (CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE,
                 QTTOTALESTOQ, VRTOTALESTOQ, DTULTMOVIMEN, VRTOTALESTM1, VRTOTALESTM2,
                 VRCLOGATU, VRCLOGATUM1,VRCLOGATUM2,VRSEGUATU,VRSEGUATUM1,VRSEGUATUM2)
             VALUES
                (@V_CDFILIAL,   @V_CDPRODUTO,  @V_CDALMOXARIFE, @V_CDLOCALESTOQ, @V_NRLOTEESTQ,
                 @V_NRSUBLOTE,  @V_QTDEESTO,   @V_VALRESTO, @V_DTPOSIESTQ, @V_VALRESTOM1, @V_VALRESTOM2,
                 @V_VRCUSTOLOG, @V_VRCLOGDIAM1,@V_VRCLOGDIAM2, @V_VRCUSTOSEG, @V_VRSEGUDIAM1, @V_VRSEGUDIAM2);
          END
          ELSE BEGIN
             UPDATE POSESTATU
             SET QTTOTALESTOQ = @V_QTDEESTO,
                 VRTOTALESTOQ = @V_VALRESTO,
                 VRTOTALESTM1 = @V_VALRESTOM2,
                 VRTOTALESTM2 = @V_VALRESTOM2,
                 DTULTMOVIMEN = @V_DTPOSIESTQ,
                 VRCLOGATU    = @V_VRCUSTOLOG,
                 VRCLOGATUM1  = @V_VRCLOGDIAM1,
                 VRCLOGATUM2  = @V_VRCLOGDIAM2,
                 VRSEGUATU    = @V_VRCUSTOSEG,
                 VRSEGUATUM1  = @V_VRSEGUDIAM1,
                 VRSEGUATUM2  = @V_VRSEGUDIAM2
             WHERE CDFILIAL     =  @V_CDFILIAL     AND
                   CDALMOXARIFE = @V_CDALMOXARIFE AND
                   CDLOCALESTOQ = @V_CDLOCALESTOQ AND
                   NRLOTEESTQ   = @V_NRLOTEESTQ   AND
                   NRSUBLOTE    = @V_NRSUBLOTE    AND
                   CDPRODUTO    = @V_CDPRODUTO;
          END;
      END;

      FETCH NEXT FROM C_PRODUTO INTO @V_CDFILIAL, @V_CDALMOXARIFE, @V_CDLOCALESTOQ,
                                     @V_NRLOTEESTQ, @V_NRSUBLOTE, @V_CDPRODUTO;
   END;
   CLOSE C_PRODUTO;
   DEALLOCATE C_PRODUTO;


   IF (ISNULL(@V_UTILALMO,'N') = 'S') OR  (ISNULL(@V_UTILLOTE, 'N') = 'S') BEGIN
      EXEC TEKNISA.ATUALIZA_ESTOQUE_CONS @P_FILIMOVI, @V_CDPROD, @P_DTINICIAL, @P_DTFINAL;
   END
   ELSE BEGIN
      INSERT INTO LISTA(NRLISTA, CDLISTA)
      (SELECT @V_NRLISTA, @V_CDPRODUTO
       FROM LISTA
       WHERE NRLISTA = @V_NRLISTA  AND
       NOT EXISTS
       (SELECT @V_NRLISTA, CDLISTA
        FROM LISTA
        WHERE NRLISTA = @V_NRLISTA));

      DECLARE C_ITENS CURSOR FOR
          SELECT CDLISTA 
          FROM LISTA
          WHERE  NRLISTA = @V_NRLISTA;
       OPEN C_ITENS;
       FETCH NEXT FROM C_ITENS INTO  @V_CDPRODUTOATU;
       WHILE (@@FETCH_STATUS = 0) BEGIN

          IF @V_DTINICIAL < @P_DTINICIAL BEGIN
               SET @V_DTPOSESTCONS = @V_DTINICIAL;
          END
          ELSE BEGIN
               SET @V_DTPOSESTCONS = @P_DTINICIAL;
          END;

          DELETE FROM POSESTCONS
          WHERE CDFILIAL  = @P_FILIMOVI         AND
                CDPRODUTO = @V_CDPRODUTOATU     AND
                DTPOSESTCON >= @V_DTPOSESTCONS;

         INSERT INTO POSESTCONS
            (CDFILIAL,  CDPRODUTO, DTPOSESTCON, QTESTDIACON, VRESTDIACON, VRESTDIACOM1, VRESTDIACOM2,
             QTESTANTCON, DTCUSTANTCON, VRESTANTCON, VRESTANTCOM1, VRESTANTCOM2, VRESTBRUTCON,
             VRESTBRUTCM1, VRESTBRUTCM2, VRBRUTANTCON, VRBRUTANTCM1, VRBRUTANTCM2, IDPOSZEROCON,
             VRCLOGCON, VRCLOGCONANT, VRCLOGCONM1, VRCLOGCONAM1, VRCLOGCONM2, VRCLOGCONAM2,
             VRSEGUCON, VRSEGUCONANT, VRSEGUCONM1, VRSEGUCONAM1, VRSEGUCONM2, VRSEGUCONAM2)
         (SELECT
            P.CDFILIAL,  P.CDPRODUTO,  P.DTPOSIESTQ, SUM(QTESTOQDIA),
           SUM(VRESTOQDIA), SUM(VRESTOQDIAM1), SUM(VRESTOQDIAM2), SUM(QTESTOQANT),
           MAX(DTCUSTANT), SUM(VRESTOQANT), SUM(VRESTOQANTM1), SUM(VRESTOQANTM2),
           SUM(VRESTOQBRUT), SUM(VRESTOQBRUM1), SUM(VRESTOQBRUM2),  SUM(VRBRUTOANT),
           SUM(VRBRUTOANTM1), SUM(VRBRUTOANTM1), MAX(IDPOSIZERO), SUM(VRCLOGDIA),
           SUM(VRCLOGDIAANT), SUM(VRCLOGDIAM1), SUM(VRCLOGDIAAM1), SUM(VRCLOGDIAM2),
           SUM(VRCLOGDIAAM2), SUM(VRSEGUDIA), SUM(VRSEGUDIAANT), SUM(VRSEGUDIAM1),
           SUM(VRSEGUDIAAM1), SUM(VRSEGUDIAM2), SUM(VRSEGUDIAAM2)
         FROM POSESTDIA P
         WHERE (P.CDFILIAL   = @P_FILIMOVI)       AND
               (P.CDPRODUTO  = @V_CDPRODUTOATU)   AND
               (DTPOSIESTQ   >= @V_DTPOSESTCONS)
         GROUP BY CDFILIAL, CDPRODUTO, DTPOSIESTQ);
         FETCH NEXT FROM C_ITENS INTO  @V_CDPRODUTOATU;
      END;
      CLOSE C_ITENS;
      DEALLOCATE C_ITENS;

/*Limpa listas geradas*/
      DELETE LISTA
      WHERE NRLISTA = @V_NRLISTA;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'ATUALIZA_ESTOQUE','5.70.XXX';
