function FieldsMetaData() {
    this.getServerNameFromDeployStep = function (serverId) {
        return {
            "name": "SERVER_NAME_" + serverId,
            "label": "Servidor",
            "isVisible": true,
            "readOnly": true,
            "class": 3,
            "template": "field/text-edit.html",
            "fieldGroup": "SERVER",
            "showOnForm": true,
            "showOnList": false,
            "showOnView": true,
            "cpIsGenerated": true,
            "filterProperties": {
                "isVisible": false
            }
        };
    };

    this.getServerBasePathFromDeployStep = function (serverId) {
        return {
            "name": "SERVER_BASE_PATH_" + serverId,
            "label": "Diretório base",
            "isVisible": true,
            "readOnly": true,
            "class": 3,
            "template": "field/text-edit.html",
            "fieldGroup": "SERVER",
            "showOnForm": true,
            "showOnList": false,
            "showOnView": true,
            "cpIsGenerated": true,
            "filterProperties": {
                "isVisible": false
            }
        };
    };

    this.getServerStatusFromDeployStep = function (serverId, css) {
        css = !css ? "cp-color-gray" : css;
        return {
            "name": "SERVER_STATUS_" + serverId,
            "label": "Status",
            "isVisible": true,
            "readOnly": true,
            "class": "2 " + css,
            "valueField": "STATUS",
            "descriptionField": "DESCRIPTION",
            "template": "field/select-native.html",
            "dataSource": {
                "rest": false,
                "localStorage": false,
                "data": [
                    {
                        "DESCRIPTION": "Aplicado",
                        "STATUS": "D"
                    },
                    {
                        "DESCRIPTION": "Erro",
                        "STATUS": "E"
                    },
                    {
                        "DESCRIPTION": "Pendente",
                        "STATUS": "P"
                    },
                    {
                        "DESCRIPTION": "Removido",
                        "STATUS": "R"
                    }
                ]
            },
            "fieldGroup": "SERVER",
            "showOnForm": true,
            "showOnList": false,
            "showOnView": true,
            "cpIsGenerated": true,
            "filterProperties": {
                "isVisible": false
            }
        };
    };

    this.getServerDateFromDeployStep = function (serverId) {
        return {
            "name": "SERVER_DATE_" + serverId,
            "label": "Data do deploy",
            "isVisible": true,
            "readOnly": true,
            "class": 2,
            "template": "field/text-edit.html",
            "fieldGroup": "SERVER",
            "showOnForm": true,
            "showOnList": false,
            "showOnView": true,
            "cpIsGenerated": true,
            "filterProperties": {
                "isVisible": false
            }
        };
    };

    this.getServerOrderFromDeployStep = function (serverId, isEdit) {
        return {
            "name": "SERVER_ORDER_" + serverId,
            "cpReadOnlyDeploy": true,
            "label": "Ordem",
            "isVisible": true,
            "class": isEdit ? 2 : 1,
            "cpClassOnEdit": 2,
            "cpClassOnView": 1,
            "template": "field/number.html",
            "fieldGroup": "SERVER",
            "showOnForm": true,
            "showOnList": false,
            "showOnView": true,
            "cpIsGenerated": true,
            "validations": {
                "required": true
            },
            "filterProperties": {
                "isVisible": false
            }
        };
    };

    this.getServerActionsFromDeployStep = function (serverId) {
        return {
            "name": "SERVER_ACTIONS_" + serverId,
            "label": "Ações",
            "isVisible": true,
            "class": 1,
            "template": "field/button.html",
            "events": [
                {
                    "name": "FieldOnClick",
                    "code": "ProductDeployStepController.deployStepFieldOnClickServerActions(args)"
                }
            ],
            "fieldGroup": "SERVER",
            "showOnForm": true,
            "showOnList": false,
            "showOnView": true,
            "cpIsGenerated": true,
            "cpInvisibleOnEdit": true,
            "productServerId": serverId,
            "filterProperties": {
                "isVisible": false
            }
        };
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('FieldsMetaData', FieldsMetaData);
});
